CryptoPkg[ALL]: CryptoPkg Package Document

  • Main Page
  • Data Structures
  • Files

CryptoPkg Package Document

0.92

Package for cryptography modules.

This Package provides cryptographic-related libraries for UEFI
security modules.

Copyright (c) 2009 - 2011, Intel Corporation. All rights reserved.

This program and the accompanying materials
are licensed and made available under the terms and conditions of the BSD License
which accompanies this distribution. The full text of the license may be found at
http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.

Package Basic Information

Version of DEC file specification | 0x00010005
Package Guid | 36470E80-36F2-4ba0-8CC8-937C7D9FF888

Known Issue

  • OPTIONAL macro for function parameter can not be dealed with doxygen, so it disapear in this document!

INDEX

  • Public Includes
  • Library Class
  • PROTOCOL
Generated on Wed Dec 14 16:19:32 2011 for CryptoPkg[ALL] by doxygen 1.5.7.1


CryptoPkg[ALL]: Public Includes

CryptoPkg Package Document

Public Includes

INDEX

  • CryptoPkg/Include
  • CryptoPkg/Include/arpa
  • CryptoPkg/Include/netinet
  • CryptoPkg/Include/openssl
  • CryptoPkg/Include/sys


CryptoPkg[ALL]: CryptoPkg/Include

CryptoPkg Package Document » Public Includes

CryptoPkg/Include

  • CryptoPkg/Include/assert.h
  • CryptoPkg/Include/ctype.h
  • CryptoPkg/Include/dirent.h
  • CryptoPkg/Include/errno.h
  • CryptoPkg/Include/limits.h
  • CryptoPkg/Include/malloc.h
  • CryptoPkg/Include/math.h
  • CryptoPkg/Include/netdb.h
  • CryptoPkg/Include/OpenSslSupport.h
  • CryptoPkg/Include/sgtty.h
  • CryptoPkg/Include/signal.h
  • CryptoPkg/Include/stdarg.h
  • CryptoPkg/Include/stddef.h
  • CryptoPkg/Include/stdio.h
  • CryptoPkg/Include/stdlib.h
  • CryptoPkg/Include/string.h
  • CryptoPkg/Include/strings.h
  • CryptoPkg/Include/syslog.h
  • CryptoPkg/Include/time.h
  • CryptoPkg/Include/unistd.h


CryptoPkg[ALL]: CryptoPkg/Include/arpa

CryptoPkg Package Document » Public Includes

CryptoPkg/Include/arpa

  • CryptoPkg/Include/arpa/inet.h


CryptoPkg[ALL]: CryptoPkg/Include/netinet

CryptoPkg Package Document » Public Includes

CryptoPkg/Include/netinet

  • CryptoPkg/Include/netinet/in.h


CryptoPkg[ALL]: CryptoPkg/Include/openssl

CryptoPkg Package Document » Public Includes

CryptoPkg/Include/openssl

  • CryptoPkg/Include/openssl/README


CryptoPkg[ALL]: CryptoPkg/Include/sys

CryptoPkg Package Document » Public Includes

CryptoPkg/Include/sys

  • CryptoPkg/Include/sys/ioctl.h
  • CryptoPkg/Include/sys/param.h
  • CryptoPkg/Include/sys/socket.h
  • CryptoPkg/Include/sys/stat.h
  • CryptoPkg/Include/sys/time.h
  • CryptoPkg/Include/sys/times.h
  • CryptoPkg/Include/sys/types.h
  • CryptoPkg/Include/sys/un.h


CryptoPkg[ALL]: Library Class

CryptoPkg Package Document

Library Class

INDEX

  • common


CryptoPkg[ALL]: common

CryptoPkg Package Document » Library Class

common

INDEX

  • BaseCryptLib


CryptoPkg[ALL]: BaseCryptLib

CryptoPkg Package Document » Library Class » common

BaseCryptLib

Defines base cryptographic library APIs. The Base Cryptographic Library provides implementations of basic cryptography primitives (Hash Serials, HMAC, RSA, Diffie-Hellman, etc) for UEFI security functionality enabling.

Copyright (c) 2009 - 2011, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.

Refer to Header File

Include/Library/BaseCryptLib.h


CryptoPkg[ALL]: PROTOCOL

CryptoPkg Package Document

PROTOCOL

INDEX

  • common


CryptoPkg[ALL]: common

CryptoPkg Package Document » PROTOCOL

common

INDEX

  • gEfiRuntimeCryptProtocolGuid


CryptoPkg[ALL]: gEfiRuntimeCryptProtocolGuid

CryptoPkg Package Document » PROTOCOL » common

gEfiRuntimeCryptProtocolGuid

Include/Protocol/RuntimeCrypt.h

PROTOCOL Information

PROTOCOL's Guid Name | PROTOCOL's Guid
gEfiRuntimeCryptProtocolGuid | { 0xe1475e0c, 0x1746, 0x4802, {0x86, 0x2e, 0x1, 0x1c, 0x2c, 0x2d, 0x9d, 0x86 }}

Refer to Header File

CryptoPkg/Include/Protocol/RuntimeCrypt.h


CryptoPkg[ALL]: Data Structures

  • Data Fields

Data Structures

Here are the data structures with brief descriptions:
dirent
EFI_RUNTIME_CRYPT_PROTOCOL
stat
tm


CryptoPkg[ALL]: dirent Struct Reference

  • Data Fields

dirent Struct Reference

Data Fields

UINT32 | d_fileno
UINT16 | d_reclen
UINT8 | d_type
UINT8 | d_namlen
char | d_name [255+1]

Field Documentation

UINT32 dirent::d_fileno

char dirent::d_name[255+1]

UINT8 dirent::d_namlen

UINT16 dirent::d_reclen

UINT8 dirent::d_type


CryptoPkg[ALL]: EFI_RUNTIME_CRYPT_PROTOCOL Struct Reference

  • Data Fields

EFI_RUNTIME_CRYPT_PROTOCOL Struct Reference

Data Fields

EFI_RUNTIME_CRYPT_SHA256_GET_CONTEXT_SIZE | Sha256GetContextSize
EFI_RUNTIME_CRYPT_SHA256_INIT | Sha256Init
EFI_RUNTIME_CRYPT_SHA256_UPDATE | Sha256Update
EFI_RUNTIME_CRYPT_SHA256_FINAL | Sha256Final
EFI_RUNTIME_CRYPT_RSA_NEW RsaNew
EFI_RUNTIME_CRYPT_RSA_FREE | RsaFree
EFI_RUNTIME_CRYPT_RSA_SET_KEY | RsaSetKey
EFI_RUNTIME_CRYPT_RSA_PKCS1_VERIFY | RsaPkcs1Verify

Detailed Description

Runtime Cryptographic Protocol Structure.

Field Documentation

EFI_RUNTIME_CRYPT_RSA_FREE EFI_RUNTIME_CRYPT_PROTOCOL::RsaFree

EFI_RUNTIME_CRYPT_RSA_NEW EFI_RUNTIME_CRYPT_PROTOCOL::RsaNew

EFI_RUNTIME_CRYPT_RSA_PKCS1_VERIFY EFI_RUNTIME_CRYPT_PROTOCOL::RsaPkcs1Verify

EFI_RUNTIME_CRYPT_RSA_SET_KEY EFI_RUNTIME_CRYPT_PROTOCOL::RsaSetKey

EFI_RUNTIME_CRYPT_SHA256_FINAL EFI_RUNTIME_CRYPT_PROTOCOL::Sha256Final

EFI_RUNTIME_CRYPT_SHA256_GET_CONTEXT_SIZE EFI_RUNTIME_CRYPT_PROTOCOL::Sha256GetContextSize

EFI_RUNTIME_CRYPT_SHA256_INIT EFI_RUNTIME_CRYPT_PROTOCOL::Sha256Init

EFI_RUNTIME_CRYPT_SHA256_UPDATE EFI_RUNTIME_CRYPT_PROTOCOL::Sha256Update


CryptoPkg[ALL]: stat Struct Reference

  • Data Fields

stat Struct Reference

Data Fields

dev_t st_dev
ino_t st_ino
mode_t st_mode
nlink_t st_nlink
uid_t st_uid
gid_t st_gid
dev_t st_rdev
time_t st_atime
long | st_atimensec
time_t st_mtime
long | st_mtimensec
time_t st_ctime
long | st_ctimensec
off_t st_size
INT64 | st_blocks
UINT32 | st_blksize
UINT32 | st_flags
UINT32 | st_gen
INT32 | st_lspare
INT64 | st_qspare [2]

Field Documentation

time_t stat::st_atime

long stat::st_atimensec

UINT32 stat::st_blksize

INT64 stat::st_blocks

time_t stat::st_ctime

long stat::st_ctimensec

dev_t stat::st_dev

UINT32 stat::st_flags

UINT32 stat::st_gen

gid_t stat::st_gid

ino_t stat::st_ino

INT32 stat::st_lspare

mode_t stat::st_mode

time_t stat::st_mtime

long stat::st_mtimensec

nlink_t stat::st_nlink

INT64 stat::st_qspare[2]

dev_t stat::st_rdev

off_t stat::st_size

uid_t stat::st_uid


CryptoPkg[ALL]: tm Struct Reference

  • Data Fields

tm Struct Reference

Data Fields

int | tm_sec
int | tm_min
int | tm_hour
int | tm_mday
int | tm_mon
int | tm_year
int | tm_wday
int | tm_yday
int | tm_isdst
long | tm_gmtoff
char * | tm_zone

Field Documentation

long tm::tm_gmtoff

int tm::tm_hour

int tm::tm_isdst

int tm::tm_mday

int tm::tm_min

int tm::tm_mon

int tm::tm_sec

int tm::tm_wday

int tm::tm_yday

int tm::tm_year

char* tm::tm_zone


CryptoPkg[ALL]: Data Fields

  • Data Fields
  • All
  • Variables
  • d
  • r
  • s
  • t
Here is a list of all struct and union fields with links to the structures/unions they belong to:

- d -

  • d_fileno : dirent
  • d_name : dirent
  • d_namlen : dirent
  • d_reclen : dirent
  • d_type : dirent

- r -

  • RsaFree : EFI_RUNTIME_CRYPT_PROTOCOL
  • RsaNew : EFI_RUNTIME_CRYPT_PROTOCOL
  • RsaPkcs1Verify : EFI_RUNTIME_CRYPT_PROTOCOL
  • RsaSetKey : EFI_RUNTIME_CRYPT_PROTOCOL

- s -

  • Sha256Final : EFI_RUNTIME_CRYPT_PROTOCOL
  • Sha256GetContextSize : EFI_RUNTIME_CRYPT_PROTOCOL
  • Sha256Init : EFI_RUNTIME_CRYPT_PROTOCOL
  • Sha256Update : EFI_RUNTIME_CRYPT_PROTOCOL
  • st_atime : stat
  • st_atimensec : stat
  • st_blksize : stat
  • st_blocks : stat
  • st_ctime : stat
  • st_ctimensec : stat
  • st_dev : stat
  • st_flags : stat
  • st_gen : stat
  • st_gid : stat
  • st_ino : stat
  • st_lspare : stat
  • st_mode : stat
  • st_mtime : stat
  • st_mtimensec : stat
  • st_nlink : stat
  • st_qspare : stat
  • st_rdev : stat
  • st_size : stat
  • st_uid : stat

- t -

  • tm_gmtoff : tm
  • tm_hour : tm
  • tm_isdst : tm
  • tm_mday : tm
  • tm_min : tm
  • tm_mon : tm
  • tm_sec : tm
  • tm_wday : tm
  • tm_yday : tm
  • tm_year : tm
  • tm_zone : tm


CryptoPkg[ALL]: File Index

  • File List
  • Globals

File List

Here is a list of all files with brief descriptions:
CryptoPkg/CryptoPkg.dec.decdoxygen
CryptoPkg/Include/assert.h
CryptoPkg/Include/ctype.h
CryptoPkg/Include/dirent.h
CryptoPkg/Include/errno.h
CryptoPkg/Include/limits.h
CryptoPkg/Include/malloc.h
CryptoPkg/Include/math.h
CryptoPkg/Include/netdb.h
CryptoPkg/Include/OpenSslSupport.h
CryptoPkg/Include/sgtty.h
CryptoPkg/Include/signal.h
CryptoPkg/Include/stdarg.h
CryptoPkg/Include/stddef.h
CryptoPkg/Include/stdio.h
CryptoPkg/Include/stdlib.h
CryptoPkg/Include/string.h
CryptoPkg/Include/strings.h
CryptoPkg/Include/syslog.h
CryptoPkg/Include/time.h
CryptoPkg/Include/unistd.h
CryptoPkg/Include/arpa/inet.h
CryptoPkg/Include/Library/BaseCryptLib.h
CryptoPkg/Include/netinet/in.h
CryptoPkg/Include/openssl/README
CryptoPkg/Include/Protocol/RuntimeCrypt.h
CryptoPkg/Include/sys/ioctl.h
CryptoPkg/Include/sys/param.h
CryptoPkg/Include/sys/socket.h
CryptoPkg/Include/sys/stat.h
CryptoPkg/Include/sys/time.h
CryptoPkg/Include/sys/times.h
CryptoPkg/Include/sys/types.h
CryptoPkg/Include/sys/un.h


CryptoPkg[ALL]: CryptoPkg/Include/assert.h File Reference

CryptoPkg/Include/assert.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/ctype.h File Reference

CryptoPkg/Include/ctype.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/dirent.h File Reference

CryptoPkg/Include/dirent.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/errno.h File Reference

CryptoPkg/Include/errno.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/limits.h File Reference

CryptoPkg/Include/limits.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/malloc.h File Reference

CryptoPkg/Include/malloc.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/math.h File Reference

CryptoPkg/Include/math.h File Reference

Detailed Description

Include file to support building OPEN SSL

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/netdb.h File Reference

CryptoPkg/Include/netdb.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/OpenSslSupport.h File Reference

CryptoPkg/Include/OpenSslSupport.h File Reference

Data Structures

struct | tm
struct | dirent
struct | stat

Defines

#define | va_list VA_LIST
#define | va_arg VA_ARG
#define | va_start VA_START
#define | va_end VA_END
#define | ENOMEM 12
#define | EINVAL 22
#define | BUFSIZ 1024
#define | INT_MAX 2147483647
#define | INT_MIN (-2147483647-1)
#define | LONG_MAX 2147483647L
#define | LONG_MIN (-2147483647-1)
#define | ULONG_MAX 0xffffffff
#define | LOG_DAEMON (3<<3)
#define | LOG_EMERG 0
#define | LOG_ALERT 1
#define | LOG_CRIT 2
#define | LOG_ERR 3
#define | LOG_WARNING 4
#define | LOG_NOTICE 5
#define | LOG_INFO 6
#define | LOG_DEBUG 7
#define | LOG_PID 0x01
#define | LOG_CONS 0x02
#define | offsetof(type, member) ( (int) & ((type*)0) -> member )
#define | memcpy(dest, source, count) CopyMem(dest,source,(UINTN)(count))
#define | memset(dest, ch, count) SetMem(dest,(UINTN)(count),(UINT8)(ch))
#define | memchr(buf, ch, count) ScanMem8(buf,(UINTN)(count),(UINT8)ch)
#define | memcmp(buf1, buf2, count) (int)(CompareMem(buf1,buf2,(UINTN)(count)))
#define | memmove(dest, source, count) CopyMem(dest,source,(UINTN)(count))
#define | strcmp AsciiStrCmp
#define | strncmp(string1, string2, count) (int)(AsciiStrnCmp(string1,string2,(UINTN)(count)))
#define | strcpy(strDest, strSource) AsciiStrCpy(strDest,strSource)
#define | strncpy(strDest, strSource, count) AsciiStrnCpy(strDest,strSource,(UINTN)count)
#define | strlen(str) (size_t)(AsciiStrLen(str))
#define | strcat(strDest, strSource) AsciiStrCat(strDest,strSource)
#define | strchr(str, ch) ScanMem8((VOID *)(str),AsciiStrSize(str),(UINT8)ch)
#define | abort() ASSERT (FALSE)
#define | assert(expression)
#define | localtime(timer) NULL
#define | gmtime_r(timer, result) (result = NULL)

Typedefs

typedef VOID * | FILE
typedef UINTN | size_t
typedef INTN | ssize_t
typedef INT64 | off_t
typedef UINT16 | mode_t
typedef long | time_t
typedef unsigned long | clock_t
typedef UINT32 | uid_t
typedef UINT32 | gid_t
typedef UINT32 | ino_t
typedef UINT32 | dev_t
typedef UINT16 | nlink_t
typedef int | pid_t
typedef void * | DIR
typedef void | __sighandler_t (int)

Functions

void * | malloc (size_t)
void * | realloc (void *, size_t)
void | free (void *)
int | isdigit (int)
int | isspace (int)
int | tolower (int)
int | isupper (int)
int | isxdigit (int)
int | isalnum (int)
void * | memcpy (void *, const void *, size_t)
void * | memset (void *, int, size_t)
void * | memchr (const void *, int, size_t)
int | memcmp (const void *, const void *, size_t)
void * | memmove (void *, const void *, size_t)
int | strcmp (const char *, const char *)
int | strncmp (const char *, const char *, size_t)
char * | strcpy (char *, const char *)
char * | strncpy (char *, const char *, size_t)
size_t | strlen (const char *)
char * | strcat (char *, const char *)
char * | strchr (const char *, int)
int | strcasecmp (const char *, const char *)
int | strncasecmp (const char *, const char *, size_t)
char * | strrchr (const char *, int)
unsigned long | strtoul (const char *, char **, int)
long | strtol (const char *, char **, int)
int | printf (const char *,...)
int | sscanf (const char *, const char *,...)
int | open (const char *, int,...)
int | chmod (const char *, mode_t)
int | stat (const char *, struct stat *)
off_t | lseek (int, off_t, int)
ssize_t | read (int, void *, size_t)
ssize_t | write (int, const void *, size_t)
int | close (int)
FILE * | fopen (const char *, const char *)
size_t | fread (void *, size_t, size_t, FILE *)
size_t | fwrite (const void *, size_t, size_t, FILE *)
char * | fgets (char *, int, FILE *)
int | fputs (const char *, FILE *)
int | fprintf (FILE *, const char *,...)
int | vfprintf (FILE *, const char *, VA_LIST)
int | fflush (FILE *)
int | fclose (FILE *)
DIR * | opendir (const char *)
struct dirent * | readdir (DIR *)
int | closedir (DIR *)
void | openlog (const char *, int, int)
void | closelog (void)
void | syslog (int, const char *,...)
time_t time (time_t *)
struct tm * | localtime (const time_t *)
struct tm * | gmtime (const time_t *)
struct tm * | gmtime_r (const time_t *, struct tm *)
uid_t | getuid (void)
uid_t | geteuid (void)
gid_t | getgid (void)
gid_t | getegid (void)
void | qsort (void *, size_t, size_t, int(*)(const void *, const void *))
char * | getenv (const char *)
void | exit (int)
__sighandler_t * | signal (int, __sighandler_t *)

Variables

int | errno
FILE * stderr
FILE * stdin
FILE * stdout

Detailed Description

Root include file to support building OpenSSL Crypto Library.

Copyright (c) 2010 - 2011, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.

Define Documentation

void abort ( ) ASSERT (FALSE)

#define assert ( expression )

#define BUFSIZ 1024

#define EINVAL 22

#define ENOMEM 12

#define gmtime_r | ( | timer,
 |  | result | ) | (result = NULL)

#define INT_MAX 2147483647

#define INT_MIN (-2147483647-1)

#define localtime ( timer ) NULL

#define LOG_ALERT 1

#define LOG_CONS 0x02

#define LOG_CRIT 2

#define LOG_DAEMON (3<<3)

#define LOG_DEBUG 7

#define LOG_EMERG 0

#define LOG_ERR 3

#define LOG_INFO 6

#define LOG_NOTICE 5

#define LOG_PID 0x01

#define LOG_WARNING 4

#define LONG_MAX 2147483647L

#define LONG_MIN (-2147483647-1)

#define memchr | ( | buf,
 |  | ch,
 |  | count | ) | ScanMem8(buf,(UINTN)(count),(UINT8)ch)

#define memcmp | ( | buf1,
 |  | buf2,
 |  | count | ) | (int)(CompareMem(buf1,buf2,(UINTN)(count)))

#define memcpy | ( | dest,
 |  | source,
 |  | count | ) | CopyMem(dest,source,(UINTN)(count))

#define memmove | ( | dest,
 |  | source,
 |  | count | ) | CopyMem(dest,source,(UINTN)(count))

#define memset | ( | dest,
 |  | ch,
 |  | count | ) | SetMem(dest,(UINTN)(count),(UINT8)(ch))

#define offsetof | ( | type,
 |  | member | ) | ( (int) & ((type*)0) -> member )

#define strcat | ( | strDest,
 |  | strSource | ) | AsciiStrCat(strDest,strSource)

#define strchr | ( | str,
 |  | ch | ) | ScanMem8((VOID *)(str),AsciiStrSize(str),(UINT8)ch)

#define strcmp AsciiStrCmp

#define strcpy | ( | strDest,
 |  | strSource | ) | AsciiStrCpy(strDest,strSource)

#define strlen ( str ) (size_t)(AsciiStrLen(str))

#define strncmp | ( | string1,
 |  | string2,
 |  | count | ) | (int)(AsciiStrnCmp(string1,string2,(UINTN)(count)))

#define strncpy | ( | strDest,
 |  | strSource,
 |  | count | ) | AsciiStrnCpy(strDest,strSource,(UINTN)count)

#define ULONG_MAX 0xffffffff

#define va_arg VA_ARG

#define va_end VA_END

#define va_list VA_LIST

#define va_start VA_START

Typedef Documentation

typedef void __sighandler_t(int)

typedef unsigned long clock_t

typedef UINT32 dev_t

typedef void* DIR

typedef VOID* FILE

typedef UINT32 gid_t

typedef UINT32 ino_t

typedef UINT16 mode_t

typedef UINT16 nlink_t

typedef INT64 off_t

typedef int pid_t

typedef UINTN size_t

typedef INTN ssize_t

typedef long time_t

typedef UINT32 uid_t

Function Documentation

int chmod | ( | const char * | ,
 |  | mode_t |
 | ) |  |

int close ( int )

int closedir ( DIR * )

void closelog ( void )

void exit ( int )

int fclose ( FILE * )

int fflush ( FILE * )

char* fgets | ( | char * | ,
 |  | int | ,
 |  | FILE * |
 | ) |  |

FILE* fopen | ( | const char * | ,
 |  | const char * |
 | ) |  |

int fprintf | ( | FILE * | ,
 |  | const char * | ,
 |  |  | ...
 | ) |  |

int fputs | ( | const char * | ,
 |  | FILE * |
 | ) |  |

size_t fread | ( | void * | ,
 |  | size_t | ,
 |  | size_t | ,
 |  | FILE * |
 | ) |  |

void free ( void * )

size_t fwrite | ( | const void * | ,
 |  | size_t | ,
 |  | size_t | ,
 |  | FILE * |
 | ) |  |

gid_t getegid ( void )

char* getenv ( const char * )

uid_t geteuid ( void )

gid_t getgid ( void )

uid_t getuid ( void )

struct tm* gmtime ( const time_t * ) [read]

struct tm* gmtime_r | ( | const time_t * | ,
 |  | struct tm * |  |
 | ) |  |  | [read]

int isalnum ( int )

int isdigit ( int )

int isspace ( int )

int isupper ( int )

int isxdigit ( int )

struct tm* localtime ( const time_t * ) [read]

off_t lseek | ( | int | ,
 |  | off_t | ,
 |  | int |
 | ) |  |

void* malloc ( size_t )

void* memchr | ( | const void * | ,
 |  | int | ,
 |  | size_t |
 | ) |  |

int memcmp | ( | const void * | ,
 |  | const void * | ,
 |  | size_t |
 | ) |  |

void* memcpy | ( | void * | ,
 |  | const void * | ,
 |  | size_t |
 | ) |  |

void* memmove | ( | void * | ,
 |  | const void * | ,
 |  | size_t |
 | ) |  |

void* memset | ( | void * | ,
 |  | int | ,
 |  | size_t |
 | ) |  |

int open | ( | const char * | ,
 |  | int | ,
 |  |  | ...
 | ) |  |

DIR* opendir ( const char * )

void openlog | ( | const char * | ,
 |  | int | ,
 |  | int |
 | ) |  |

int printf | ( | const char * | ,
 |  |  | ...
 | ) |  |

void qsort | ( | void * | ,
 |  | size_t | ,
 |  | size_t | ,
 |  | int(*)(const void *, const void *) |
 | ) |  |

ssize_t read | ( | int | ,
 |  | void * | ,
 |  | size_t |
 | ) |  |

struct dirent* readdir ( DIR * ) [read]

void* realloc | ( | void * | ,
 |  | size_t |
 | ) |  |

__sighandler_t* signal | ( | int | ,
 |  | __sighandler_t * |
 | ) |  |

int sscanf | ( | const char * | ,
 |  | const char * | ,
 |  |  | ...
 | ) |  |

int stat | ( | const char * | ,
 |  | struct stat * |
 | ) |  |

int strcasecmp | ( | const char * | ,
 |  | const char * |
 | ) |  |

char* strcat | ( | char * | ,
 |  | const char * |
 | ) |  |

char* strchr | ( | const char * | ,
 |  | int |
 | ) |  |

int strcmp | ( | const char * | ,
 |  | const char * |
 | ) |  |

char* strcpy | ( | char * | ,
 |  | const char * |
 | ) |  |

size_t strlen ( const char * )

int strncasecmp | ( | const char * | ,
 |  | const char * | ,
 |  | size_t |
 | ) |  |

int strncmp | ( | const char * | ,
 |  | const char * | ,
 |  | size_t |
 | ) |  |

char * strncpy | ( | char * | ,
 |  | const char * | ,
 |  | size_t |
 | ) |  |

char* strrchr | ( | const char * | ,
 |  | int |
 | ) |  |

long strtol | ( | const char * | ,
 |  | char ** | ,
 |  | int |
 | ) |  |

unsigned long strtoul | ( | const char * | ,
 |  | char ** | ,
 |  | int |
 | ) |  |

void syslog | ( | int | ,
 |  | const char * | ,
 |  |  | ...
 | ) |  |

time_t time ( time_t * )

int tolower ( int )

int vfprintf | ( | FILE * | ,
 |  | const char * | ,
 |  | VA_LIST |
 | ) |  |

ssize_t write | ( | int | ,
 |  | const void * | ,
 |  | size_t |
 | ) |  |

Variable Documentation

int errno

FILE* stderr

FILE* stdin

FILE* stdout


CryptoPkg[ALL]: CryptoPkg/Include/sgtty.h File Reference

CryptoPkg/Include/sgtty.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/signal.h File Reference

CryptoPkg/Include/signal.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/stdarg.h File Reference

CryptoPkg/Include/stdarg.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/stddef.h File Reference

CryptoPkg/Include/stddef.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/stdio.h File Reference

CryptoPkg/Include/stdio.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/stdlib.h File Reference

CryptoPkg/Include/stdlib.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/string.h File Reference

CryptoPkg/Include/string.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/strings.h File Reference

CryptoPkg/Include/strings.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/syslog.h File Reference

CryptoPkg/Include/syslog.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/time.h File Reference

CryptoPkg/Include/time.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/unistd.h File Reference

CryptoPkg/Include/unistd.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/arpa/inet.h File Reference

CryptoPkg/Include/arpa/inet.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/Library/BaseCryptLib.h File Reference

CryptoPkg/Include/Library/BaseCryptLib.h File Reference

Defines

#define | MD4_DIGEST_SIZE 16
#define | MD5_DIGEST_SIZE 16
#define | SHA1_DIGEST_SIZE 20
#define | SHA256_DIGEST_SIZE 32
#define | TDES_BLOCK_SIZE 8
#define | AES_BLOCK_SIZE 16

Enumerations

enum RSA_KEY_TAG {
RsaKeyN, RsaKeyE, RsaKeyD, RsaKeyP,
RsaKeyQ, RsaKeyDp, RsaKeyDq, RsaKeyQInv
}

Functions

UINTN EFIAPI | Md4GetContextSize (VOID)
BOOLEAN EFIAPI | Md4Init (OUT VOID *Md4Context)
BOOLEAN EFIAPI | Md4Duplicate (IN CONST VOID *Md4Context, OUT VOID *NewMd4Context)
BOOLEAN EFIAPI | Md4Update (IN OUT VOID *Md4Context, IN CONST VOID *Data, IN UINTN DataSize)
BOOLEAN EFIAPI | Md4Final (IN OUT VOID *Md4Context, OUT UINT8 *HashValue)
UINTN EFIAPI | Md5GetContextSize (VOID)
BOOLEAN EFIAPI | Md5Init (OUT VOID *Md5Context)
BOOLEAN EFIAPI | Md5Duplicate (IN CONST VOID *Md5Context, OUT VOID *NewMd5Context)
BOOLEAN EFIAPI | Md5Update (IN OUT VOID *Md5Context, IN CONST VOID *Data, IN UINTN DataSize)
BOOLEAN EFIAPI | Md5Final (IN OUT VOID *Md5Context, OUT UINT8 *HashValue)
UINTN EFIAPI | Sha1GetContextSize (VOID)
BOOLEAN EFIAPI | Sha1Init (OUT VOID *Sha1Context)
BOOLEAN EFIAPI | Sha1Duplicate (IN CONST VOID *Sha1Context, OUT VOID *NewSha1Context)
BOOLEAN EFIAPI | Sha1Update (IN OUT VOID *Sha1Context, IN CONST VOID *Data, IN UINTN DataSize)
BOOLEAN EFIAPI | Sha1Final (IN OUT VOID *Sha1Context, OUT UINT8 *HashValue)
UINTN EFIAPI | Sha256GetContextSize (VOID)
BOOLEAN EFIAPI | Sha256Init (OUT VOID *Sha256Context)
BOOLEAN EFIAPI | Sha256Duplicate (IN CONST VOID *Sha256Context, OUT VOID *NewSha256Context)
BOOLEAN EFIAPI | Sha256Update (IN OUT VOID *Sha256Context, IN CONST VOID *Data, IN UINTN DataSize)
BOOLEAN EFIAPI | Sha256Final (IN OUT VOID *Sha256Context, OUT UINT8 *HashValue)
UINTN EFIAPI | HmacMd5GetContextSize (VOID)
BOOLEAN EFIAPI | HmacMd5Init (OUT VOID *HmacMd5Context, IN CONST UINT8 *Key, IN UINTN KeySize)
BOOLEAN EFIAPI | HmacMd5Duplicate (IN CONST VOID *HmacMd5Context, OUT VOID *NewHmacMd5Context)
BOOLEAN EFIAPI | HmacMd5Update (IN OUT VOID *HmacMd5Context, IN CONST VOID *Data, IN UINTN DataSize)
BOOLEAN EFIAPI | HmacMd5Final (IN OUT VOID *HmacMd5Context, OUT UINT8 *HmacValue)
UINTN EFIAPI | HmacSha1GetContextSize (VOID)
BOOLEAN EFIAPI | HmacSha1Init (OUT VOID *HmacSha1Context, IN CONST UINT8 *Key, IN UINTN KeySize)
BOOLEAN EFIAPI | HmacSha1Duplicate (IN CONST VOID *HmacSha1Context, OUT VOID *NewHmacSha1Context)
BOOLEAN EFIAPI | HmacSha1Update (IN OUT VOID *HmacSha1Context, IN CONST VOID *Data, IN UINTN DataSize)
BOOLEAN EFIAPI | HmacSha1Final (IN OUT VOID *HmacSha1Context, OUT UINT8 *HmacValue)
UINTN EFIAPI | TdesGetContextSize (VOID)
BOOLEAN EFIAPI | TdesInit (OUT VOID *TdesContext, IN CONST UINT8 *Key, IN UINTN KeyLength)
BOOLEAN EFIAPI | TdesEcbEncrypt (IN VOID *TdesContext, IN CONST UINT8 *Input, IN UINTN InputSize, OUT UINT8 *Output)
BOOLEAN EFIAPI | TdesEcbDecrypt (IN VOID *TdesContext, IN CONST UINT8 *Input, IN UINTN InputSize, OUT UINT8 *Output)
BOOLEAN EFIAPI | TdesCbcEncrypt (IN VOID *TdesContext, IN CONST UINT8 *Input, IN UINTN InputSize, IN CONST UINT8 *Ivec, OUT UINT8 *Output)
BOOLEAN EFIAPI | TdesCbcDecrypt (IN VOID *TdesContext, IN CONST UINT8 *Input, IN UINTN InputSize, IN CONST UINT8 *Ivec, OUT UINT8 *Output)
UINTN EFIAPI | AesGetContextSize (VOID)
BOOLEAN EFIAPI | AesInit (OUT VOID *AesContext, IN CONST UINT8 *Key, IN UINTN KeyLength)
BOOLEAN EFIAPI | AesEcbEncrypt (IN VOID *AesContext, IN CONST UINT8 *Input, IN UINTN InputSize, OUT UINT8 *Output)
BOOLEAN EFIAPI | AesEcbDecrypt (IN VOID *AesContext, IN CONST UINT8 *Input, IN UINTN InputSize, OUT UINT8 *Output)
BOOLEAN EFIAPI | AesCbcEncrypt (IN VOID *AesContext, IN CONST UINT8 *Input, IN UINTN InputSize, IN CONST UINT8 *Ivec, OUT UINT8 *Output)
BOOLEAN EFIAPI | AesCbcDecrypt (IN VOID *AesContext, IN CONST UINT8 *Input, IN UINTN InputSize, IN CONST UINT8 *Ivec, OUT UINT8 *Output)
UINTN EFIAPI | Arc4GetContextSize (VOID)
BOOLEAN EFIAPI | Arc4Init (OUT VOID *Arc4Context, IN CONST UINT8 *Key, IN UINTN KeySize)
BOOLEAN EFIAPI | Arc4Encrypt (IN OUT VOID *Arc4Context, IN CONST UINT8 *Input, IN UINTN InputSize, OUT UINT8 *Output)
BOOLEAN EFIAPI | Arc4Decrypt (IN OUT VOID *Arc4Context, IN UINT8 *Input, IN UINTN InputSize, OUT UINT8 *Output)
BOOLEAN EFIAPI | Arc4Reset (IN OUT VOID *Arc4Context)
VOID *EFIAPI | RsaNew (VOID)
VOID EFIAPI | RsaFree (IN VOID *RsaContext)
BOOLEAN EFIAPI | RsaSetKey (IN OUT VOID *RsaContext, IN RSA_KEY_TAG KeyTag, IN CONST UINT8 *BigNumber, IN UINTN BnSize)
BOOLEAN EFIAPI | RsaGetKey (IN OUT VOID *RsaContext, IN RSA_KEY_TAG KeyTag, OUT UINT8 *BigNumber, IN OUT UINTN *BnSize)
BOOLEAN EFIAPI | RsaGenerateKey (IN OUT VOID *RsaContext, IN UINTN ModulusLength, IN CONST UINT8 *PublicExponent, IN UINTN PublicExponentSize)
BOOLEAN EFIAPI | RsaCheckKey (IN VOID *RsaContext)
BOOLEAN EFIAPI | RsaPkcs1Sign (IN VOID *RsaContext, IN CONST UINT8 *MessageHash, IN UINTN HashSize, OUT UINT8 *Signature, IN OUT UINTN *SigSize)
BOOLEAN EFIAPI | RsaPkcs1Verify (IN VOID *RsaContext, IN CONST UINT8 *MessageHash, IN UINTN HashSize, IN UINT8 *Signature, IN UINTN SigSize)
BOOLEAN EFIAPI | RsaGetPrivateKeyFromPem (IN CONST UINT8 *PemData, IN UINTN PemSize, IN CONST CHAR8 *Password, OUT VOID **RsaContext)
BOOLEAN EFIAPI | RsaGetPublicKeyFromX509 (IN CONST UINT8 *Cert, IN UINTN CertSize, OUT VOID **RsaContext)
BOOLEAN EFIAPI | X509GetSubjectName (IN CONST UINT8 *Cert, IN UINTN CertSize, OUT UINT8 *CertSubject, IN OUT UINTN *SubjectSize)
BOOLEAN EFIAPI | X509VerifyCert (IN CONST UINT8 *Cert, IN UINTN CertSize, IN CONST UINT8 *CACert, IN UINTN CACertSize)
BOOLEAN EFIAPI | X509ConstructCertificate (IN CONST UINT8 *Cert, IN UINTN CertSize, OUT UINT8 **SingleX509Cert)
BOOLEAN EFIAPI | X509ConstructCertificateStack (IN OUT UINT8 **X509Stack,...)
VOID EFIAPI | X509Free (IN VOID *X509Cert)
VOID EFIAPI | X509StackFree (IN VOID *X509Stack)
BOOLEAN EFIAPI | Pkcs7Sign (IN CONST UINT8 *PrivateKey, IN UINTN PrivateKeySize, IN CONST UINT8 *KeyPassword, IN UINT8 *InData, IN UINTN InDataSize, IN UINT8 *SignCert, IN UINT8 *OtherCerts, OUT UINT8 **SignedData, OUT UINTN *SignedDataSize)
BOOLEAN EFIAPI | Pkcs7Verify (IN CONST UINT8 *P7Data, IN UINTN P7Size, IN CONST UINT8 *TrustedCert, IN UINTN CertSize, IN CONST UINT8 *InData, IN UINTN DataSize)
BOOLEAN EFIAPI | AuthenticodeVerify (IN CONST UINT8 *AuthData, IN UINTN DataSize, IN CONST UINT8 *TrustedCert, IN UINTN CertSize, IN CONST UINT8 *ImageHash, IN UINTN HashSize)
VOID *EFIAPI | DhNew (VOID)
VOID EFIAPI | DhFree (IN VOID *DhContext)
BOOLEAN EFIAPI | DhGenerateParameter (IN OUT VOID *DhContext, IN UINTN Generator, IN UINTN PrimeLength, OUT UINT8 *Prime)
BOOLEAN EFIAPI | DhSetParameter (IN OUT VOID *DhContext, IN UINTN Generator, IN UINTN PrimeLength, IN CONST UINT8 *Prime)
BOOLEAN EFIAPI | DhGenerateKey (IN OUT VOID *DhContext, OUT UINT8 *PublicKey, IN OUT UINTN *PublicKeySize)
BOOLEAN EFIAPI | DhComputeKey (IN OUT VOID *DhContext, IN CONST UINT8 *PeerPublicKey, IN UINTN PeerPublicKeySize, OUT UINT8 *Key, IN OUT UINTN *KeySize)
BOOLEAN EFIAPI | RandomSeed (IN CONST UINT8 *Seed, IN UINTN SeedSize)
BOOLEAN EFIAPI | RandomBytes (OUT UINT8 *Output, IN UINTN Size)

Detailed Description

Defines base cryptographic library APIs. The Base Cryptographic Library provides implementations of basic cryptography primitives (Hash Serials, HMAC, RSA, Diffie-Hellman, etc) for UEFI security functionality enabling.

Copyright (c) 2009 - 2011, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.

Define Documentation

#define AES_BLOCK_SIZE 16

AES block size in bytes

#define MD4_DIGEST_SIZE 16

MD4 digest size in bytes

#define MD5_DIGEST_SIZE 16

MD5 digest size in bytes

#define SHA1_DIGEST_SIZE 20

SHA-1 digest size in bytes.

#define SHA256_DIGEST_SIZE 32

SHA-256 digest size in bytes

#define TDES_BLOCK_SIZE 8

TDES block size in bytes

Enumeration Type Documentation

enum RSA_KEY_TAG

RSA Key Tags Definition used in RsaSetKey() function for key component identification.

Enumerator:
RsaKeyN | RSA public Modulus (N).
RsaKeyE | RSA Public exponent (e).
RsaKeyD | RSA Private exponent (d).
RsaKeyP | RSA secret prime factor of Modulus (p).
RsaKeyQ | RSA secret prime factor of Modules (q).
RsaKeyDp | p's CRT exponent (== d mod (p - 1))
RsaKeyDq | q's CRT exponent (== d mod (q - 1))
RsaKeyQInv | The CRT coefficient (== 1/q mod p).

Function Documentation

BOOLEAN EFIAPI AesCbcDecrypt | ( | IN VOID * | AesContext,
 |  | IN CONST UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | IN CONST UINT8 * | Ivec,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs AES decryption on a data buffer of the specified size in CBC mode.

This function performs AES decryption on data buffer pointed by Input, of specified size of InputSize, in CBC mode. InputSize must be multiple of block size (16 bytes). This function does not perform padding. Caller must perform padding, if necessary, to ensure valid input data size. Initialization vector should be one block size (16 bytes). AesContext should be already correctly initialized by AesInit(). Behavior with invalid AES context is undefined.

If AesContext is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If InputSize is not multiple of block size (16 bytes), then ASSERT(). If Ivec is NULL, then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | AesContext | Pointer to the AES context.
[in] | Input | Pointer to the buffer containing the data to be encrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[in] | Ivec | Pointer to initialization vector.
[out] | Output | Pointer to a buffer that receives the AES encryption output.
Return values:
TRUE | AES decryption succeeded.
FALSE | AES decryption failed.

BOOLEAN EFIAPI AesCbcEncrypt | ( | IN VOID * | AesContext,
 |  | IN CONST UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | IN CONST UINT8 * | Ivec,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs AES encryption on a data buffer of the specified size in CBC mode.

This function performs AES encryption on data buffer pointed by Input, of specified size of InputSize, in CBC mode. InputSize must be multiple of block size (16 bytes). This function does not perform padding. Caller must perform padding, if necessary, to ensure valid input data size. Initialization vector should be one block size (16 bytes). AesContext should be already correctly initialized by AesInit(). Behavior with invalid AES context is undefined.

If AesContext is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If InputSize is not multiple of block size (16 bytes), then ASSERT(). If Ivec is NULL, then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | AesContext | Pointer to the AES context.
[in] | Input | Pointer to the buffer containing the data to be encrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[in] | Ivec | Pointer to initialization vector.
[out] | Output | Pointer to a buffer that receives the AES encryption output.
Return values:
TRUE | AES encryption succeeded.
FALSE | AES encryption failed.

BOOLEAN EFIAPI AesEcbDecrypt | ( | IN VOID * | AesContext,
 |  | IN CONST UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs AES decryption on a data buffer of the specified size in ECB mode.

This function performs AES decryption on data buffer pointed by Input, of specified size of InputSize, in ECB mode. InputSize must be multiple of block size (16 bytes). This function does not perform padding. Caller must perform padding, if necessary, to ensure valid input data size. AesContext should be already correctly initialized by AesInit(). Behavior with invalid AES context is undefined.

If AesContext is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If InputSize is not multiple of block size (16 bytes), then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | AesContext | Pointer to the AES context.
[in] | Input | Pointer to the buffer containing the data to be decrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[out] | Output | Pointer to a buffer that receives the AES decryption output.
Return values:
TRUE | AES decryption succeeded.
FALSE | AES decryption failed.

BOOLEAN EFIAPI AesEcbEncrypt | ( | IN VOID * | AesContext,
 |  | IN CONST UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs AES encryption on a data buffer of the specified size in ECB mode.

This function performs AES encryption on data buffer pointed by Input, of specified size of InputSize, in ECB mode. InputSize must be multiple of block size (16 bytes). This function does not perform padding. Caller must perform padding, if necessary, to ensure valid input data size. AesContext should be already correctly initialized by AesInit(). Behavior with invalid AES context is undefined.

If AesContext is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If InputSize is not multiple of block size (16 bytes), then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | AesContext | Pointer to the AES context.
[in] | Input | Pointer to the buffer containing the data to be encrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[out] | Output | Pointer to a buffer that receives the AES encryption output.
Return values:
TRUE | AES encryption succeeded.
FALSE | AES encryption failed.

UINTN EFIAPI AesGetContextSize ( VOID )

Retrieves the size, in bytes, of the context buffer required for AES operations.

Returns:
The size, in bytes, of the context buffer required for AES operations.

BOOLEAN EFIAPI AesInit | ( | OUT VOID * | AesContext,
 |  | IN CONST UINT8 * | Key,
 |  | IN UINTN | KeyLength
 | ) |  |

Initializes user-supplied memory as AES context for subsequent use.

This function initializes user-supplied memory pointed by AesContext as AES context. In addtion, it sets up all AES key materials for subsequent encryption and decryption operations. There are 3 options for key length, 128 bits, 192 bits, and 256 bits.

If AesContext is NULL, then ASSERT(). If Key is NULL, then ASSERT(). If KeyLength is not valid, then ASSERT().

Parameters:
[out] | AesContext | Pointer to AES context being initialized.
[in] | Key | Pointer to the user-supplied AES key.
[in] | KeyLength | Length of AES key in bits.
Return values:
TRUE | AES context initialization succeeded.
FALSE | AES context initialization failed.

BOOLEAN EFIAPI Arc4Decrypt | ( | IN OUT VOID * | Arc4Context,
 |  | IN UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs ARC4 decryption on a data buffer of the specified size.

This function performs ARC4 decryption on data buffer pointed by Input, of specified size of InputSize. Arc4Context should be already correctly initialized by Arc4Init(). Behavior with invalid ARC4 context is undefined.

If Arc4Context is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | Arc4Context | Pointer to the ARC4 context.
[in] | Input | Pointer to the buffer containing the data to be decrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[out] | Output | Pointer to a buffer that receives the ARC4 decryption output.
Return values:
TRUE | ARC4 decryption succeeded.
FALSE | ARC4 decryption failed.

BOOLEAN EFIAPI Arc4Encrypt | ( | IN OUT VOID * | Arc4Context,
 |  | IN CONST UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs ARC4 encryption on a data buffer of the specified size.

This function performs ARC4 encryption on data buffer pointed by Input, of specified size of InputSize. Arc4Context should be already correctly initialized by Arc4Init(). Behavior with invalid ARC4 context is undefined.

If Arc4Context is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | Arc4Context | Pointer to the ARC4 context.
[in] | Input | Pointer to the buffer containing the data to be encrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[out] | Output | Pointer to a buffer that receives the ARC4 encryption output.
Return values:
TRUE | ARC4 encryption succeeded.
FALSE | ARC4 encryption failed.

UINTN EFIAPI Arc4GetContextSize ( VOID )

Retrieves the size, in bytes, of the context buffer required for ARC4 operations.

Returns:
The size, in bytes, of the context buffer required for ARC4 operations.

BOOLEAN EFIAPI Arc4Init | ( | OUT VOID * | Arc4Context,
 |  | IN CONST UINT8 * | Key,
 |  | IN UINTN | KeySize
 | ) |  |

Initializes user-supplied memory as ARC4 context for subsequent use.

This function initializes user-supplied memory pointed by Arc4Context as ARC4 context. In addtion, it sets up all ARC4 key materials for subsequent encryption and decryption operations.

If Arc4Context is NULL, then ASSERT(). If Key is NULL, then ASSERT(). If KeySize does not in the range of [5, 256] bytes, then ASSERT().

Parameters:
[out] | Arc4Context | Pointer to ARC4 context being initialized.
[in] | Key | Pointer to the user-supplied ARC4 key.
[in] | KeySize | Size of ARC4 key in bytes.
Return values:
TRUE | ARC4 context initialization succeeded.
FALSE | ARC4 context initialization failed.

BOOLEAN EFIAPI Arc4Reset ( IN OUT VOID * Arc4Context )

Resets the ARC4 context to the initial state.

The function resets the ARC4 context to the state it had immediately after the ARC4Init() function call. Contrary to ARC4Init(), Arc4Reset() requires no secret key as input, but ARC4 context should be already correctly initialized by ARC4Init().

If Arc4Context is NULL, then ASSERT().

Parameters:
[in,out] Arc4Context Pointer to the ARC4 context.
Return values:
TRUE | ARC4 reset succeeded.
FALSE | ARC4 reset failed.

BOOLEAN EFIAPI AuthenticodeVerify | ( | IN CONST UINT8 * | AuthData,
 |  | IN UINTN | DataSize,
 |  | IN CONST UINT8 * | TrustedCert,
 |  | IN UINTN | CertSize,
 |  | IN CONST UINT8 * | ImageHash,
 |  | IN UINTN | HashSize
 | ) |  |

Verifies the validility of a PE/COFF Authenticode Signature as described in "Windows Authenticode Portable Executable Signature Format".

If AuthData is NULL, then ASSERT(). If ImageHash is NULL, then ASSERT().

Parameters:
[in] | AuthData | Pointer to the Authenticode Signature retrieved from signed PE/COFF image to be verified.
[in] | DataSize | Size of the Authenticode Signature in bytes.
[in] | TrustedCert | Pointer to a trusted/root certificate encoded in DER, which is used for certificate chain verification.
[in] | CertSize | Size of the trusted certificate in bytes.
[in] | ImageHash | Pointer to the original image file hash value. The procudure for calculating the image hash value is described in Authenticode specification.
[in] | HashSize | Size of Image hash value in bytes.
Return values:
TRUE | The specified Authenticode Signature is valid.
FALSE | Invalid Authenticode Signature.

BOOLEAN EFIAPI DhComputeKey | ( | IN OUT VOID * | DhContext,
 |  | IN CONST UINT8 * | PeerPublicKey,
 |  | IN UINTN | PeerPublicKeySize,
 |  | OUT UINT8 * | Key,
 |  | IN OUT UINTN * | KeySize
 | ) |  |

Computes exchanged common key.

Given peer's public key, this function computes the exchanged common key, based on its own context including value of prime modulus and random secret exponent.

If DhContext is NULL, then ASSERT(). If PeerPublicKey is NULL, then ASSERT(). If KeySize is NULL, then ASSERT(). If KeySize is large enough but Key is NULL, then ASSERT().

Parameters:
[in,out] | DhContext | Pointer to the DH context.
[in] | PeerPublicKey | Pointer to the peer's public key.
[in] | PeerPublicKeySize | Size of peer's public key in bytes.
[out] | Key | Pointer to the buffer to receive generated key.
[in,out] | KeySize | On input, the size of Key buffer in bytes. On output, the size of data returned in Key buffer in bytes.
Return values:
TRUE | DH exchanged key generation succeeded.
FALSE | DH exchanged key generation failed.
FALSE | KeySize is not large enough.

VOID EFIAPI DhFree ( IN VOID * DhContext )

Release the specified DH context.

If DhContext is NULL, then ASSERT().

Parameters:
[in] DhContext Pointer to the DH context to be released.

BOOLEAN EFIAPI DhGenerateKey | ( | IN OUT VOID * | DhContext,
 |  | OUT UINT8 * | PublicKey,
 |  | IN OUT UINTN * | PublicKeySize
 | ) |  |

Generates DH public key.

This function generates random secret exponent, and computes the public key, which is returned via parameter PublicKey and PublicKeySize. DH context is updated accordingly. If the PublicKey buffer is too small to hold the public key, FALSE is returned and PublicKeySize is set to the required buffer size to obtain the public key.

If DhContext is NULL, then ASSERT(). If PublicKeySize is NULL, then ASSERT(). If PublicKeySize is large enough but PublicKey is NULL, then ASSERT().

Parameters:
[in,out] | DhContext | Pointer to the DH context.
[out] | PublicKey | Pointer to the buffer to receive generated public key.
[in,out] | PublicKeySize | On input, the size of PublicKey buffer in bytes. On output, the size of data returned in PublicKey buffer in bytes.
Return values:
TRUE | DH public key generation succeeded.
FALSE | DH public key generation failed.
FALSE | PublicKeySize is not large enough.

BOOLEAN EFIAPI DhGenerateParameter | ( | IN OUT VOID * | DhContext,
 |  | IN UINTN | Generator,
 |  | IN UINTN | PrimeLength,
 |  | OUT UINT8 * | Prime
 | ) |  |

Generates DH parameter.

Given generator g, and length of prime number p in bits, this function generates p, and sets DH context according to value of g and p.

Before this function can be invoked, pseudorandom number generator must be correctly initialized by RandomSeed().

If DhContext is NULL, then ASSERT(). If Prime is NULL, then ASSERT().

Parameters:
[in,out] | DhContext | Pointer to the DH context.
[in] | Generator | Value of generator.
[in] | PrimeLength | Length in bits of prime to be generated.
[out] | Prime | Pointer to the buffer to receive the generated prime number.
Return values:
TRUE | DH pamameter generation succeeded.
FALSE | Value of Generator is not supported.
FALSE | PRNG fails to generate random prime number with PrimeLength.

VOID* EFIAPI DhNew ( VOID )

Allocates and Initializes one Diffie-Hellman Context for subsequent use.

Returns:
Pointer to the Diffie-Hellman Context that has been initialized. If the allocations fails, DhNew() returns NULL.

BOOLEAN EFIAPI DhSetParameter | ( | IN OUT VOID * | DhContext,
 |  | IN UINTN | Generator,
 |  | IN UINTN | PrimeLength,
 |  | IN CONST UINT8 * | Prime
 | ) |  |

Sets generator and prime parameters for DH.

Given generator g, and prime number p, this function and sets DH context accordingly.

If DhContext is NULL, then ASSERT(). If Prime is NULL, then ASSERT().

Parameters:
[in,out] | DhContext | Pointer to the DH context.
[in] | Generator | Value of generator.
[in] | PrimeLength | Length in bits of prime to be generated.
[in] | Prime | Pointer to the prime number.
Return values:
TRUE | DH pamameter setting succeeded.
FALSE | Value of Generator is not supported.
FALSE | Value of Generator is not suitable for the Prime.
FALSE | Value of Prime is not a prime number.
FALSE | Value of Prime is not a safe prime number.

BOOLEAN EFIAPI HmacMd5Duplicate | ( | IN CONST VOID * | HmacMd5Context,
 |  | OUT VOID * | NewHmacMd5Context
 | ) |  |

Makes a copy of an existing HMAC-MD5 context.

If HmacMd5Context is NULL, then ASSERT(). If NewHmacMd5Context is NULL, then ASSERT().

Parameters:
[in] | HmacMd5Context | Pointer to HMAC-MD5 context being copied.
[out] | NewHmacMd5Context | Pointer to new HMAC-MD5 context.
Return values:
TRUE | HMAC-MD5 context copy succeeded.
FALSE | HMAC-MD5 context copy failed.

BOOLEAN EFIAPI HmacMd5Final | ( | IN OUT VOID * | HmacMd5Context,
 |  | OUT UINT8 * | HmacValue
 | ) |  |

Completes computation of the HMAC-MD5 digest value.

This function completes HMAC-MD5 hash computation and retrieves the digest value into the specified memory. After this function has been called, the HMAC-MD5 context cannot be used again. HMAC-MD5 context should be already correctly intialized by HmacMd5Init(), and should not be finalized by HmacMd5Final(). Behavior with invalid HMAC-MD5 context is undefined.

If HmacMd5Context is NULL, then ASSERT(). If HashValue is NULL, then ASSERT().

Parameters:
[in,out] | HmacMd5Context | Pointer to the HMAC-MD5 context.
[out] | HashValue | Pointer to a buffer that receives the HMAC-MD5 digest value (16 bytes).
Return values:
TRUE | HMAC-MD5 digest computation succeeded.
FALSE | HMAC-MD5 digest computation failed.

UINTN EFIAPI HmacMd5GetContextSize ( VOID )

Retrieves the size, in bytes, of the context buffer required for HMAC-MD5 operations.

Returns:
The size, in bytes, of the context buffer required for HMAC-MD5 operations.

BOOLEAN EFIAPI HmacMd5Init | ( | OUT VOID * | HmacMd5Context,
 |  | IN CONST UINT8 * | Key,
 |  | IN UINTN | KeySize
 | ) |  |

Initializes user-supplied memory pointed by HmacMd5Context as HMAC-MD5 context for subsequent use.

If HmacMd5Context is NULL, then ASSERT().

Parameters:
[out] | HmacMd5Context | Pointer to HMAC-MD5 context being initialized.
[in] | Key | Pointer to the user-supplied key.
[in] | KeySize | Key size in bytes.
Return values:
TRUE | HMAC-MD5 context initialization succeeded.
FALSE | HMAC-MD5 context initialization failed.

BOOLEAN EFIAPI HmacMd5Update | ( | IN OUT VOID * | HmacMd5Context,
 |  | IN CONST VOID * | Data,
 |  | IN UINTN | DataSize
 | ) |  |

Digests the input data and updates HMAC-MD5 context.

This function performs HMAC-MD5 digest on a data buffer of the specified size. It can be called multiple times to compute the digest of long or discontinuous data streams. HMAC-MD5 context should be already correctly intialized by HmacMd5Init(), and should not be finalized by HmacMd5Final(). Behavior with invalid context is undefined.

If HmacMd5Context is NULL, then ASSERT().

Parameters:
[in,out] | HmacMd5Context | Pointer to the HMAC-MD5 context.
[in] | Data | Pointer to the buffer containing the data to be digested.
[in] | DataSize | Size of Data buffer in bytes.
Return values:
TRUE | HMAC-MD5 data digest succeeded.
FALSE | HMAC-MD5 data digest failed.

BOOLEAN EFIAPI HmacSha1Duplicate | ( | IN CONST VOID * | HmacSha1Context,
 |  | OUT VOID * | NewHmacSha1Context
 | ) |  |

Makes a copy of an existing HMAC-SHA1 context.

If HmacSha1Context is NULL, then ASSERT(). If NewHmacSha1Context is NULL, then ASSERT().

Parameters:
[in] | HmacSha1Context | Pointer to HMAC-SHA1 context being copied.
[out] | NewHmacSha1Context | Pointer to new HMAC-SHA1 context.
Return values:
TRUE | HMAC-SHA1 context copy succeeded.
FALSE | HMAC-SHA1 context copy failed.

BOOLEAN EFIAPI HmacSha1Final | ( | IN OUT VOID * | HmacSha1Context,
 |  | OUT UINT8 * | HmacValue
 | ) |  |

Completes computation of the HMAC-SHA1 digest value.

This function completes HMAC-SHA1 hash computation and retrieves the digest value into the specified memory. After this function has been called, the HMAC-SHA1 context cannot be used again. HMAC-SHA1 context should be already correctly intialized by HmacSha1Init(), and should not be finalized by HmacSha1Final(). Behavior with invalid HMAC-SHA1 context is undefined.

If HmacSha1Context is NULL, then ASSERT(). If HashValue is NULL, then ASSERT().

Parameters:
[in,out] | HmacSha1Context | Pointer to the HMAC-SHA1 context.
[out] | HashValue | Pointer to a buffer that receives the HMAC-SHA1 digest value (20 bytes).
Return values:
TRUE | HMAC-SHA1 digest computation succeeded.
FALSE | HMAC-SHA1 digest computation failed.

UINTN EFIAPI HmacSha1GetContextSize ( VOID )

Retrieves the size, in bytes, of the context buffer required for HMAC-SHA1 operations.

Returns:
The size, in bytes, of the context buffer required for HMAC-SHA1 operations.

BOOLEAN EFIAPI HmacSha1Init | ( | OUT VOID * | HmacSha1Context,
 |  | IN CONST UINT8 * | Key,
 |  | IN UINTN | KeySize
 | ) |  |

Initializes user-supplied memory pointed by HmacSha1Context as HMAC-SHA1 context for subsequent use.

If HmacSha1Context is NULL, then ASSERT().

Parameters:
[out] | HmacSha1Context | Pointer to HMAC-SHA1 context being initialized.
[in] | Key | Pointer to the user-supplied key.
[in] | KeySize | Key size in bytes.
Return values:
TRUE | HMAC-SHA1 context initialization succeeded.
FALSE | HMAC-SHA1 context initialization failed.

BOOLEAN EFIAPI HmacSha1Update | ( | IN OUT VOID * | HmacSha1Context,
 |  | IN CONST VOID * | Data,
 |  | IN UINTN | DataSize
 | ) |  |

Digests the input data and updates HMAC-SHA1 context.

This function performs HMAC-SHA1 digest on a data buffer of the specified size. It can be called multiple times to compute the digest of long or discontinuous data streams. HMAC-SHA1 context should be already correctly intialized by HmacSha1Init(), and should not be finalized by HmacSha1Final(). Behavior with invalid context is undefined.

If HmacSha1Context is NULL, then ASSERT().

Parameters:
[in,out] | HmacSha1Context | Pointer to the HMAC-SHA1 context.
[in] | Data | Pointer to the buffer containing the data to be digested.
[in] | DataSize | Size of Data buffer in bytes.
Return values:
TRUE | HMAC-SHA1 data digest succeeded.
FALSE | HMAC-SHA1 data digest failed.

BOOLEAN EFIAPI Md4Duplicate | ( | IN CONST VOID * | Md4Context,
 |  | OUT VOID * | NewMd4Context
 | ) |  |

Makes a copy of an existing MD4 context.

If Md4Context is NULL, then ASSERT(). If NewMd4Context is NULL, then ASSERT().

Parameters:
[in] | Md4Context | Pointer to MD4 context being copied.
[out] | NewMd4Context | Pointer to new MD4 context.
Return values:
TRUE | MD4 context copy succeeded.
FALSE | MD4 context copy failed.

BOOLEAN EFIAPI Md4Final | ( | IN OUT VOID * | Md4Context,
 |  | OUT UINT8 * | HashValue
 | ) |  |

Completes computation of the MD4 digest value.

This function completes MD4 hash computation and retrieves the digest value into the specified memory. After this function has been called, the MD4 context cannot be used again. MD4 context should be already correctly intialized by Md4Init(), and should not be finalized by Md4Final(). Behavior with invalid MD4 context is undefined.

If Md4Context is NULL, then ASSERT(). If HashValue is NULL, then ASSERT().

Parameters:
[in,out] | Md4Context | Pointer to the MD4 context.
[out] | HashValue | Pointer to a buffer that receives the MD4 digest value (16 bytes).
Return values:
TRUE | MD4 digest computation succeeded.
FALSE | MD4 digest computation failed.

UINTN EFIAPI Md4GetContextSize ( VOID )

Retrieves the size, in bytes, of the context buffer required for MD4 hash operations.

Returns:
The size, in bytes, of the context buffer required for MD4 hash operations.

BOOLEAN EFIAPI Md4Init ( OUT VOID * Md4Context )

Initializes user-supplied memory pointed by Md4Context as MD4 hash context for subsequent use.

If Md4Context is NULL, then ASSERT().

Parameters:
[out] Md4Context Pointer to MD4 context being initialized.
Return values:
TRUE | MD4 context initialization succeeded.
FALSE | MD4 context initialization failed.

BOOLEAN EFIAPI Md4Update | ( | IN OUT VOID * | Md4Context,
 |  | IN CONST VOID * | Data,
 |  | IN UINTN | DataSize
 | ) |  |

Digests the input data and updates MD4 context.

This function performs MD4 digest on a data buffer of the specified size. It can be called multiple times to compute the digest of long or discontinuous data streams. MD4 context should be already correctly intialized by Md4Init(), and should not be finalized by Md4Final(). Behavior with invalid context is undefined.

If Md4Context is NULL, then ASSERT().

Parameters:
[in,out] | Md4Context | Pointer to the MD4 context.
[in] | Data | Pointer to the buffer containing the data to be hashed.
[in] | DataSize | Size of Data buffer in bytes.
Return values:
TRUE | MD4 data digest succeeded.
FALSE | MD4 data digest failed.

BOOLEAN EFIAPI Md5Duplicate | ( | IN CONST VOID * | Md5Context,
 |  | OUT VOID * | NewMd5Context
 | ) |  |

Makes a copy of an existing MD5 context.

If Md5Context is NULL, then ASSERT(). If NewMd5Context is NULL, then ASSERT().

Parameters:
[in] | Md5Context | Pointer to MD5 context being copied.
[out] | NewMd5Context | Pointer to new MD5 context.
Return values:
TRUE | MD5 context copy succeeded.
FALSE | MD5 context copy failed.

BOOLEAN EFIAPI Md5Final | ( | IN OUT VOID * | Md5Context,
 |  | OUT UINT8 * | HashValue
 | ) |  |

Completes computation of the MD5 digest value.

This function completes MD5 hash computation and retrieves the digest value into the specified memory. After this function has been called, the MD5 context cannot be used again. MD5 context should be already correctly intialized by Md5Init(), and should not be finalized by Md5Final(). Behavior with invalid MD5 context is undefined.

If Md5Context is NULL, then ASSERT(). If HashValue is NULL, then ASSERT().

Parameters:
[in,out] | Md5Context | Pointer to the MD5 context.
[out] | HashValue | Pointer to a buffer that receives the MD5 digest value (16 bytes).
Return values:
TRUE | MD5 digest computation succeeded.
FALSE | MD5 digest computation failed.

UINTN EFIAPI Md5GetContextSize ( VOID )

Retrieves the size, in bytes, of the context buffer required for MD5 hash operations.

Returns:
The size, in bytes, of the context buffer required for MD5 hash operations.

BOOLEAN EFIAPI Md5Init ( OUT VOID * Md5Context )

Initializes user-supplied memory pointed by Md5Context as MD5 hash context for subsequent use.

If Md5Context is NULL, then ASSERT().

Parameters:
[out] Md5Context Pointer to MD5 context being initialized.
Return values:
TRUE | MD5 context initialization succeeded.
FALSE | MD5 context initialization failed.

BOOLEAN EFIAPI Md5Update | ( | IN OUT VOID * | Md5Context,
 |  | IN CONST VOID * | Data,
 |  | IN UINTN | DataSize
 | ) |  |

Digests the input data and updates MD5 context.

This function performs MD5 digest on a data buffer of the specified size. It can be called multiple times to compute the digest of long or discontinuous data streams. MD5 context should be already correctly intialized by Md5Init(), and should not be finalized by Md5Final(). Behavior with invalid context is undefined.

If Md5Context is NULL, then ASSERT().

Parameters:
[in,out] | Md5Context | Pointer to the MD5 context.
[in] | Data | Pointer to the buffer containing the data to be hashed.
[in] | DataSize | Size of Data buffer in bytes.
Return values:
TRUE | MD5 data digest succeeded.
FALSE | MD5 data digest failed.

BOOLEAN EFIAPI Pkcs7Sign | ( | IN CONST UINT8 * | PrivateKey,
 |  | IN UINTN | PrivateKeySize,
 |  | IN CONST UINT8 * | KeyPassword,
 |  | IN UINT8 * | InData,
 |  | IN UINTN | InDataSize,
 |  | IN UINT8 * | SignCert,
 |  | IN UINT8 * | OtherCerts,
 |  | OUT UINT8 ** | SignedData,
 |  | OUT UINTN * | SignedDataSize
 | ) |  |

Creates a PKCS#7 signedData as described in "PKCS #7: Cryptographic Message Syntax Standard, version 1.5". This interface is only intended to be used for application to perform PKCS#7 functionality validation.

Parameters:
[in] | PrivateKey | Pointer to the PEM-formatted private key data for data signing.
[in] | PrivateKeySize | Size of the PEM private key data in bytes.
[in] | KeyPassword | NULL-terminated passphrase used for encrypted PEM key data.
[in] | InData | Pointer to the content to be signed.
[in] | InDataSize | Size of InData in bytes.
[in] | SignCert | Pointer to signer's DER-encoded certificate to sign with.
[in] | OtherCerts | Pointer to an optional additional set of certificates to include in the PKCS#7 signedData (e.g. any intermediate CAs in the chain).
[out] | SignedData | Pointer to output PKCS#7 signedData.
[out] | SignedDataSize | Size of SignedData in bytes.
Return values:
TRUE | PKCS#7 data signing succeeded.
FALSE | PKCS#7 data signing failed.

BOOLEAN EFIAPI Pkcs7Verify | ( | IN CONST UINT8 * | P7Data,
 |  | IN UINTN | P7Size,
 |  | IN CONST UINT8 * | TrustedCert,
 |  | IN UINTN | CertSize,
 |  | IN CONST UINT8 * | InData,
 |  | IN UINTN | DataSize
 | ) |  |

Verifies the validility of a PKCS#7 signed data as described in "PKCS #7: Cryptographic Message Syntax Standard".

If P7Data is NULL, then ASSERT().

Parameters:
[in] | P7Data | Pointer to the PKCS#7 message to verify.
[in] | P7Size | Size of the PKCS#7 message in bytes.
[in] | TrustedCert | Pointer to a trusted/root certificate encoded in DER, which is used for certificate chain verification.
[in] | CertSize | Size of the trusted certificate in bytes.
[in] | InData | Pointer to the content to be verified.
[in] | DataSize | Size of InData in bytes.
Return values:
TRUE | The specified PKCS#7 signed data is valid.
FALSE | Invalid PKCS#7 signed data.

BOOLEAN EFIAPI RandomBytes | ( | OUT UINT8 * | Output,
 |  | IN UINTN | Size
 | ) |  |

Generates a pseudorandom byte stream of the specified size.

If Output is NULL, then ASSERT().

Parameters:
[out] | Output | Pointer to buffer to receive random value.
[in] | Size | Size of randome bytes to generate.
Return values:
TRUE | Pseudorandom byte stream generated successfully.
FALSE | Pseudorandom number generator fails to generate due to lack of entropy.

BOOLEAN EFIAPI RandomSeed | ( | IN CONST UINT8 * | Seed,
 |  | IN UINTN | SeedSize
 | ) |  |

Sets up the seed value for the pseudorandom number generator.

This function sets up the seed value for the pseudorandom number generator. If Seed is not NULL, then the seed passed in is used. If Seed is NULL, then default seed is used.

Parameters:
[in] | Seed | Pointer to seed value. If NULL, default seed is used.
[in] | SeedSize | Size of seed value. If Seed is NULL, this parameter is ignored.
Return values:
TRUE | Pseudorandom number generator has enough entropy for random generation.
FALSE | Pseudorandom number generator does not have enough entropy for random generation.

BOOLEAN EFIAPI RsaCheckKey ( IN VOID * RsaContext )

Validates key components of RSA context.

This function validates key compoents of RSA context in following aspects:

  • Whether p is a prime
  • Whether q is a prime
  • Whether n = p * q
  • Whether d*e = 1 mod lcm(p-1,q-1)

If RsaContext is NULL, then ASSERT().

Parameters:
[in] RsaContext Pointer to RSA context to check.
Return values:
TRUE | RSA key components are valid.
FALSE | RSA key components are not valid.

VOID EFIAPI RsaFree ( IN VOID * RsaContext )

Release the specified RSA context.

If RsaContext is NULL, then ASSERT().

Parameters:
[in] RsaContext Pointer to the RSA context to be released.

BOOLEAN EFIAPI RsaGenerateKey | ( | IN OUT VOID * | RsaContext,
 |  | IN UINTN | ModulusLength,
 |  | IN CONST UINT8 * | PublicExponent,
 |  | IN UINTN | PublicExponentSize
 | ) |  |

Generates RSA key components.

This function generates RSA key components. It takes RSA public exponent E and length in bits of RSA modulus N as input, and generates all key components. If PublicExponent is NULL, the default RSA public exponent (0x10001) will be used.

Before this function can be invoked, pseudorandom number generator must be correctly initialized by RandomSeed().

If RsaContext is NULL, then ASSERT().

Parameters:
[in,out] | RsaContext | Pointer to RSA context being set.
[in] | ModulusLength | Length of RSA modulus N in bits.
[in] | PublicExponent | Pointer to RSA public exponent.
[in] | PublicExponentSize | Size of RSA public exponent buffer in bytes.
Return values:
TRUE | RSA key component was generated successfully.
FALSE | Invalid RSA key component tag.

BOOLEAN EFIAPI RsaGetKey | ( | IN OUT VOID * | RsaContext,
 |  | IN RSA_KEY_TAG | KeyTag,
 |  | OUT UINT8 * | BigNumber,
 |  | IN OUT UINTN * | BnSize
 | ) |  |

Gets the tag-designated RSA key component from the established RSA context.

This function retrieves the tag-designated RSA key component from the established RSA context as a non-negative integer (octet string format represented in RSA PKCS#1). If specified key component has not been set or has been cleared, then returned BnSize is set to 0. If the BigNumber buffer is too small to hold the contents of the key, FALSE is returned and BnSize is set to the required buffer size to obtain the key.

If RsaContext is NULL, then ASSERT(). If BnSize is NULL, then ASSERT(). If BnSize is large enough but BigNumber is NULL, then ASSERT().

Parameters:
[in,out] | RsaContext | Pointer to RSA context being set.
[in] | KeyTag | Tag of RSA key component being set.
[out] | BigNumber | Pointer to octet integer buffer.
[in,out] | BnSize | On input, the size of big number buffer in bytes. On output, the size of data returned in big number buffer in bytes.
Return values:
TRUE | RSA key component was retrieved successfully.
FALSE | Invalid RSA key component tag.
FALSE | BnSize is too small.

BOOLEAN EFIAPI RsaGetPrivateKeyFromPem | ( | IN CONST UINT8 * | PemData,
 |  | IN UINTN | PemSize,
 |  | IN CONST CHAR8 * | Password,
 |  | OUT VOID ** | RsaContext
 | ) |  |

Retrieve the RSA Private Key from the password-protected PEM key data.

Parameters:
[in] | PemData | Pointer to the PEM-encoded key data to be retrieved.
[in] | PemSize | Size of the PEM key data in bytes.
[in] | Password | NULL-terminated passphrase used for encrypted PEM key data.
[out] | RsaContext | Pointer to new-generated RSA context which contain the retrieved RSA private key component. Use RsaFree() function to free the resource.
If PemData is NULL, then ASSERT(). If RsaContext is NULL, then ASSERT().

Return values:
TRUE | RSA Private Key was retrieved successfully.
FALSE | Invalid PEM key data or incorrect password.

BOOLEAN EFIAPI RsaGetPublicKeyFromX509 | ( | IN CONST UINT8 * | Cert,
 |  | IN UINTN | CertSize,
 |  | OUT VOID ** | RsaContext
 | ) |  |

Retrieve the RSA Public Key from one DER-encoded X509 certificate.

Parameters:
[in] | Cert | Pointer to the DER-encoded X509 certificate.
[in] | CertSize | Size of the X509 certificate in bytes.
[out] | RsaContext | Pointer to new-generated RSA context which contain the retrieved RSA public key component. Use RsaFree() function to free the resource.
If Cert is NULL, then ASSERT(). If RsaContext is NULL, then ASSERT().

Return values:
TRUE | RSA Public Key was retrieved successfully.
FALSE | Fail to retrieve RSA public key from X509 certificate.

VOID* EFIAPI RsaNew ( VOID )

Allocates and initializes one RSA context for subsequent use.

Returns:
Pointer to the RSA context that has been initialized. If the allocations fails, RsaNew() returns NULL.

BOOLEAN EFIAPI RsaPkcs1Sign | ( | IN VOID * | RsaContext,
 |  | IN CONST UINT8 * | MessageHash,
 |  | IN UINTN | HashSize,
 |  | OUT UINT8 * | Signature,
 |  | IN OUT UINTN * | SigSize
 | ) |  |

Carries out the RSA-SSA signature generation with EMSA-PKCS1-v1_5 encoding scheme.

This function carries out the RSA-SSA signature generation with EMSA-PKCS1-v1_5 encoding scheme defined in RSA PKCS#1. If the Signature buffer is too small to hold the contents of signature, FALSE is returned and SigSize is set to the required buffer size to obtain the signature.

If RsaContext is NULL, then ASSERT(). If MessageHash is NULL, then ASSERT(). If HashSize is not equal to the size of MD5, SHA-1 or SHA-256 digest, then ASSERT(). If SigSize is large enough but Signature is NULL, then ASSERT().

Parameters:
[in] | RsaContext | Pointer to RSA context for signature generation.
[in] | MessageHash | Pointer to octet message hash to be signed.
[in] | HashSize | Size of the message hash in bytes.
[out] | Signature | Pointer to buffer to receive RSA PKCS1-v1_5 signature.
[in,out] | SigSize | On input, the size of Signature buffer in bytes. On output, the size of data returned in Signature buffer in bytes.
Return values:
TRUE | Signature successfully generated in PKCS1-v1_5.
FALSE | Signature generation failed.
FALSE | SigSize is too small.

BOOLEAN EFIAPI RsaPkcs1Verify | ( | IN VOID * | RsaContext,
 |  | IN CONST UINT8 * | MessageHash,
 |  | IN UINTN | HashSize,
 |  | IN UINT8 * | Signature,
 |  | IN UINTN | SigSize
 | ) |  |

Verifies the RSA-SSA signature with EMSA-PKCS1-v1_5 encoding scheme defined in RSA PKCS#1.

If RsaContext is NULL, then ASSERT(). If MessageHash is NULL, then ASSERT(). If Signature is NULL, then ASSERT(). If HashSize is not equal to the size of MD5, SHA-1, SHA-256 digest, then ASSERT().

Parameters:
[in] | RsaContext | Pointer to RSA context for signature verification.
[in] | MessageHash | Pointer to octet message hash to be checked.
[in] | HashSize | Size of the message hash in bytes.
[in] | Signature | Pointer to RSA PKCS1-v1_5 signature to be verified.
[in] | SigSize | Size of signature in bytes.
Return values:
TRUE | Valid signature encoded in PKCS1-v1_5.
FALSE | Invalid signature or invalid RSA context.

BOOLEAN EFIAPI RsaSetKey | ( | IN OUT VOID * | RsaContext,
 |  | IN RSA_KEY_TAG | KeyTag,
 |  | IN CONST UINT8 * | BigNumber,
 |  | IN UINTN | BnSize
 | ) |  |

Sets the tag-designated key component into the established RSA context.

This function sets the tag-designated RSA key component into the established RSA context from the user-specified non-negative integer (octet string format represented in RSA PKCS#1). If BigNumber is NULL, then the specified key componenet in RSA context is cleared.

If RsaContext is NULL, then ASSERT().

Parameters:
[in,out] | RsaContext | Pointer to RSA context being set.
[in] | KeyTag | Tag of RSA key component being set.
[in] | BigNumber | Pointer to octet integer buffer. If NULL, then the specified key componenet in RSA context is cleared.
[in] | BnSize | Size of big number buffer in bytes. If BigNumber is NULL, then it is ignored.
Return values:
TRUE | RSA key component was set successfully.
FALSE | Invalid RSA key component tag.

BOOLEAN EFIAPI Sha1Duplicate | ( | IN CONST VOID * | Sha1Context,
 |  | OUT VOID * | NewSha1Context
 | ) |  |

Makes a copy of an existing SHA-1 context.

If Sha1Context is NULL, then ASSERT(). If NewSha1Context is NULL, then ASSERT().

Parameters:
[in] | Sha1Context | Pointer to SHA-1 context being copied.
[out] | NewSha1Context | Pointer to new SHA-1 context.
Return values:
TRUE | SHA-1 context copy succeeded.
FALSE | SHA-1 context copy failed.

BOOLEAN EFIAPI Sha1Final | ( | IN OUT VOID * | Sha1Context,
 |  | OUT UINT8 * | HashValue
 | ) |  |

Completes computation of the SHA-1 digest value.

This function completes SHA-1 hash computation and retrieves the digest value into the specified memory. After this function has been called, the SHA-1 context cannot be used again. SHA-1 context should be already correctly intialized by Sha1Init(), and should not be finalized by Sha1Final(). Behavior with invalid SHA-1 context is undefined.

If Sha1Context is NULL, then ASSERT(). If HashValue is NULL, then ASSERT().

Parameters:
[in,out] | Sha1Context | Pointer to the SHA-1 context.
[out] | HashValue | Pointer to a buffer that receives the SHA-1 digest value (20 bytes).
Return values:
TRUE | SHA-1 digest computation succeeded.
FALSE | SHA-1 digest computation failed.

UINTN EFIAPI Sha1GetContextSize ( VOID )

Retrieves the size, in bytes, of the context buffer required for SHA-1 hash operations.

Returns:
The size, in bytes, of the context buffer required for SHA-1 hash operations.

BOOLEAN EFIAPI Sha1Init ( OUT VOID * Sha1Context )

Initializes user-supplied memory pointed by Sha1Context as SHA-1 hash context for subsequent use.

If Sha1Context is NULL, then ASSERT().

Parameters:
[out] Sha1Context Pointer to SHA-1 context being initialized.
Return values:
TRUE | SHA-1 context initialization succeeded.
FALSE | SHA-1 context initialization failed.

BOOLEAN EFIAPI Sha1Update | ( | IN OUT VOID * | Sha1Context,
 |  | IN CONST VOID * | Data,
 |  | IN UINTN | DataSize
 | ) |  |

Digests the input data and updates SHA-1 context.

This function performs SHA-1 digest on a data buffer of the specified size. It can be called multiple times to compute the digest of long or discontinuous data streams. SHA-1 context should be already correctly intialized by Sha1Init(), and should not be finalized by Sha1Final(). Behavior with invalid context is undefined.

If Sha1Context is NULL, then ASSERT().

Parameters:
[in,out] | Sha1Context | Pointer to the SHA-1 context.
[in] | Data | Pointer to the buffer containing the data to be hashed.
[in] | DataSize | Size of Data buffer in bytes.
Return values:
TRUE | SHA-1 data digest succeeded.
FALSE | SHA-1 data digest failed.

BOOLEAN EFIAPI Sha256Duplicate | ( | IN CONST VOID * | Sha256Context,
 |  | OUT VOID * | NewSha256Context
 | ) |  |

Makes a copy of an existing SHA-256 context.

If Sha256Context is NULL, then ASSERT(). If NewSha256Context is NULL, then ASSERT().

Parameters:
[in] | Sha256Context | Pointer to SHA-256 context being copied.
[out] | NewSha256Context | Pointer to new SHA-256 context.
Return values:
TRUE | SHA-256 context copy succeeded.
FALSE | SHA-256 context copy failed.

BOOLEAN EFIAPI Sha256Final | ( | IN OUT VOID * | Sha256Context,
 |  | OUT UINT8 * | HashValue
 | ) |  |

Completes computation of the SHA-256 digest value.

This function completes SHA-256 hash computation and retrieves the digest value into the specified memory. After this function has been called, the SHA-256 context cannot be used again. SHA-256 context should be already correctly intialized by Sha256Init(), and should not be finalized by Sha256Final(). Behavior with invalid SHA-256 context is undefined.

If Sha256Context is NULL, then ASSERT(). If HashValue is NULL, then ASSERT().

Parameters:
[in,out] | Sha256Context | Pointer to the SHA-256 context.
[out] | HashValue | Pointer to a buffer that receives the SHA-256 digest value (32 bytes).
Return values:
TRUE | SHA-256 digest computation succeeded.
FALSE | SHA-256 digest computation failed.

UINTN EFIAPI Sha256GetContextSize ( VOID )

Retrieves the size, in bytes, of the context buffer required for SHA-256 hash operations.

Returns:
The size, in bytes, of the context buffer required for SHA-256 hash operations.

BOOLEAN EFIAPI Sha256Init ( OUT VOID * Sha256Context )

Initializes user-supplied memory pointed by Sha256Context as SHA-256 hash context for subsequent use.

If Sha256Context is NULL, then ASSERT().

Parameters:
[out] Sha256Context Pointer to SHA-256 context being initialized.
Return values:
TRUE | SHA-256 context initialization succeeded.
FALSE | SHA-256 context initialization failed.

BOOLEAN EFIAPI Sha256Update | ( | IN OUT VOID * | Sha256Context,
 |  | IN CONST VOID * | Data,
 |  | IN UINTN | DataSize
 | ) |  |

Digests the input data and updates SHA-256 context.

This function performs SHA-256 digest on a data buffer of the specified size. It can be called multiple times to compute the digest of long or discontinuous data streams. SHA-256 context should be already correctly intialized by Sha256Init(), and should not be finalized by Sha256Final(). Behavior with invalid context is undefined.

If Sha256Context is NULL, then ASSERT().

Parameters:
[in,out] | Sha256Context | Pointer to the SHA-256 context.
[in] | Data | Pointer to the buffer containing the data to be hashed.
[in] | DataSize | Size of Data buffer in bytes.
Return values:
TRUE | SHA-256 data digest succeeded.
FALSE | SHA-256 data digest failed.

BOOLEAN EFIAPI TdesCbcDecrypt | ( | IN VOID * | TdesContext,
 |  | IN CONST UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | IN CONST UINT8 * | Ivec,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs TDES decryption on a data buffer of the specified size in CBC mode.

This function performs TDES decryption on data buffer pointed by Input, of specified size of InputSize, in CBC mode. InputSize must be multiple of block size (8 bytes). This function does not perform padding. Caller must perform padding, if necessary, to ensure valid input data size. Initialization vector should be one block size (8 bytes). TdesContext should be already correctly initialized by TdesInit(). Behavior with invalid TDES context is undefined.

If TdesContext is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If InputSize is not multiple of block size (8 bytes), then ASSERT(). If Ivec is NULL, then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | TdesContext | Pointer to the TDES context.
[in] | Input | Pointer to the buffer containing the data to be encrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[in] | Ivec | Pointer to initialization vector.
[out] | Output | Pointer to a buffer that receives the TDES encryption output.
Return values:
TRUE | TDES decryption succeeded.
FALSE | TDES decryption failed.

BOOLEAN EFIAPI TdesCbcEncrypt | ( | IN VOID * | TdesContext,
 |  | IN CONST UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | IN CONST UINT8 * | Ivec,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs TDES encryption on a data buffer of the specified size in CBC mode.

This function performs TDES encryption on data buffer pointed by Input, of specified size of InputSize, in CBC mode. InputSize must be multiple of block size (8 bytes). This function does not perform padding. Caller must perform padding, if necessary, to ensure valid input data size. Initialization vector should be one block size (8 bytes). TdesContext should be already correctly initialized by TdesInit(). Behavior with invalid TDES context is undefined.

If TdesContext is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If InputSize is not multiple of block size (8 bytes), then ASSERT(). If Ivec is NULL, then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | TdesContext | Pointer to the TDES context.
[in] | Input | Pointer to the buffer containing the data to be encrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[in] | Ivec | Pointer to initialization vector.
[out] | Output | Pointer to a buffer that receives the TDES encryption output.
Return values:
TRUE | TDES encryption succeeded.
FALSE | TDES encryption failed.

BOOLEAN EFIAPI TdesEcbDecrypt | ( | IN VOID * | TdesContext,
 |  | IN CONST UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs TDES decryption on a data buffer of the specified size in ECB mode.

This function performs TDES decryption on data buffer pointed by Input, of specified size of InputSize, in ECB mode. InputSize must be multiple of block size (8 bytes). This function does not perform padding. Caller must perform padding, if necessary, to ensure valid input data size. TdesContext should be already correctly initialized by TdesInit(). Behavior with invalid TDES context is undefined.

If TdesContext is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If InputSize is not multiple of block size (8 bytes), then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | TdesContext | Pointer to the TDES context.
[in] | Input | Pointer to the buffer containing the data to be decrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[out] | Output | Pointer to a buffer that receives the TDES decryption output.
Return values:
TRUE | TDES decryption succeeded.
FALSE | TDES decryption failed.

BOOLEAN EFIAPI TdesEcbEncrypt | ( | IN VOID * | TdesContext,
 |  | IN CONST UINT8 * | Input,
 |  | IN UINTN | InputSize,
 |  | OUT UINT8 * | Output
 | ) |  |

Performs TDES encryption on a data buffer of the specified size in ECB mode.

This function performs TDES encryption on data buffer pointed by Input, of specified size of InputSize, in ECB mode. InputSize must be multiple of block size (8 bytes). This function does not perform padding. Caller must perform padding, if necessary, to ensure valid input data size. TdesContext should be already correctly initialized by TdesInit(). Behavior with invalid TDES context is undefined.

If TdesContext is NULL, then ASSERT(). If Input is NULL, then ASSERT(). If InputSize is not multiple of block size (8 bytes), then ASSERT(). If Output is NULL, then ASSERT().

Parameters:
[in] | TdesContext | Pointer to the TDES context.
[in] | Input | Pointer to the buffer containing the data to be encrypted.
[in] | InputSize | Size of the Input buffer in bytes.
[out] | Output | Pointer to a buffer that receives the TDES encryption output.
Return values:
TRUE | TDES encryption succeeded.
FALSE | TDES encryption failed.

UINTN EFIAPI TdesGetContextSize ( VOID )

Retrieves the size, in bytes, of the context buffer required for TDES operations.

Returns:
The size, in bytes, of the context buffer required for TDES operations.

BOOLEAN EFIAPI TdesInit | ( | OUT VOID * | TdesContext,
 |  | IN CONST UINT8 * | Key,
 |  | IN UINTN | KeyLength
 | ) |  |

Initializes user-supplied memory as TDES context for subsequent use.

This function initializes user-supplied memory pointed by TdesContext as TDES context. In addtion, it sets up all TDES key materials for subsequent encryption and decryption operations. There are 3 key options as follows: KeyLength = 64, Keying option 1: K1 == K2 == K3 (Backward compatibility with DES) KeyLength = 128, Keying option 2: K1 != K2 and K3 = K1 (Less Security) KeyLength = 192 Keying option 3: K1 != K2 != K3 (Strongest)

If TdesContext is NULL, then ASSERT(). If Key is NULL, then ASSERT(). If KeyLength is not valid, then ASSERT().

Parameters:
[out] | TdesContext | Pointer to TDES context being initialized.
[in] | Key | Pointer to the user-supplied TDES key.
[in] | KeyLength | Length of TDES key in bits.
Return values:
TRUE | TDES context initialization succeeded.
FALSE | TDES context initialization failed.

BOOLEAN EFIAPI X509ConstructCertificate | ( | IN CONST UINT8 * | Cert,
 |  | IN UINTN | CertSize,
 |  | OUT UINT8 ** | SingleX509Cert
 | ) |  |

Construct a X509 object from DER-encoded certificate data.

If Cert is NULL, then ASSERT(). If SingleX509Cert is NULL, then ASSERT().

Parameters:
[in] | Cert | Pointer to the DER-encoded certificate data.
[in] | CertSize | The size of certificate data in bytes.
[out] | SingleX509Cert | The generated X509 object.
Return values:
TRUE | The X509 object generation succeeded.
FALSE | The operation failed.

BOOLEAN EFIAPI X509ConstructCertificateStack | ( | IN OUT UINT8 ** | X509Stack,
 |  |  | ...
 | ) |  |

Construct a X509 stack object from a list of DER-encoded certificate data.

If X509Stack is NULL, then ASSERT().

Parameters:
[in,out] X509Stack On input, pointer to an existing X509 stack object. On output, pointer to the X509 stack object with new inserted X509 certificate.
... A list of DER-encoded single certificate data followed by certificate size. A NULL terminates the list. The pairs are the arguments to X509ConstructCertificate().
Return values:
TRUE | The X509 stack construction succeeded.
FALSE | The construction operation failed.

VOID EFIAPI X509Free ( IN VOID * X509Cert )

Release the specified X509 object.

If X509Cert is NULL, then ASSERT().

Parameters:
[in] X509Cert Pointer to the X509 object to be released.

BOOLEAN EFIAPI X509GetSubjectName | ( | IN CONST UINT8 * | Cert,
 |  | IN UINTN | CertSize,
 |  | OUT UINT8 * | CertSubject,
 |  | IN OUT UINTN * | SubjectSize
 | ) |  |

Retrieve the subject bytes from one X.509 certificate.

Parameters:
[in] | Cert | Pointer to the DER-encoded X509 certificate.
[in] | CertSize | Size of the X509 certificate in bytes.
[out] | CertSubject | Pointer to the retrieved certificate subject bytes.
[in,out] | SubjectSize | The size in bytes of the CertSubject buffer on input, and the size of buffer returned CertSubject on output.
If Cert is NULL, then ASSERT(). If SubjectSize is NULL, then ASSERT().

Return values:
TRUE | The certificate subject retrieved successfully.
FALSE | Invalid certificate, or the SubjectSize is too small for the result. The SubjectSize will be updated with the required size.

VOID EFIAPI X509StackFree ( IN VOID * X509Stack )

Release the specified X509 stack object.

If X509Stack is NULL, then ASSERT().

Parameters:
[in] X509Stack Pointer to the X509 stack object to be released.

BOOLEAN EFIAPI X509VerifyCert | ( | IN CONST UINT8 * | Cert,
 |  | IN UINTN | CertSize,
 |  | IN CONST UINT8 * | CACert,
 |  | IN UINTN | CACertSize
 | ) |  |

Verify one X509 certificate was issued by the trusted CA.

Parameters:
[in] | Cert | Pointer to the DER-encoded X509 certificate to be verified.
[in] | CertSize | Size of the X509 certificate in bytes.
[in] | CACert | Pointer to the DER-encoded trusted CA certificate.
[in] | CACertSize | Size of the CA Certificate in bytes.
If Cert is NULL, then ASSERT(). If CACert is NULL, then ASSERT().

Return values:
TRUE | The certificate was issued by the trusted CA.
FALSE | Invalid certificate or the certificate was not issued by the given trusted CA.


CryptoPkg[ALL]: CryptoPkg/Include/netinet/in.h File Reference

CryptoPkg/Include/netinet/in.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/openssl/README File Reference

CryptoPkg/Include/openssl/README File Reference

Generated on Wed Dec 14 16:19:32 2011 for CryptoPkg[ALL] by doxygen 1.5.7.1


CryptoPkg[ALL]: CryptoPkg/Include/Protocol/RuntimeCrypt.h File Reference

CryptoPkg/Include/Protocol/RuntimeCrypt.h File Reference

Data Structures

struct | EFI_RUNTIME_CRYPT_PROTOCOL

Defines

#define | EFI_RUNTIME_CRYPT_PROTOCOL_GUID

Typedefs

typedef IN CONST VOID * | Data
typedef IN CONST VOID IN UINTN | DataLength
typedef OUT UINT8 * | HashValue
typedef VOID *EFIAPI * | EFI_RUNTIME_CRYPT_RSA_NEW (VOID)
typedef IN RSA_KEY_TAG | KeyTag
typedef IN RSA_KEY_TAG IN
CONST UINT8 * 		BigNumber
typedef IN RSA_KEY_TAG IN
CONST UINT8 IN UINTN 		BnLength
typedef IN CONST UINT8 * | MessageHash
typedef IN CONST UINT8 IN UINTN | HashLength
typedef IN CONST UINT8 IN
UINTN IN UINT8 * 		Signature
typedef IN CONST UINT8 IN
UINTN IN UINT8 IN UINTN 		SigLength

Functions

typedef | UINTN (EFIAPI *EFI_RUNTIME_CRYPT_SHA256_GET_CONTEXT_SIZE)(VOID)
typedef | BOOLEAN (EFIAPI *EFI_RUNTIME_CRYPT_SHA256_INIT)(IN OUT VOID *Sha256Context)
typedef | VOID (EFIAPI *EFI_RUNTIME_CRYPT_RSA_FREE)(IN VOID *RsaContext)

Variables

EFI_GUID | gEfiRuntimeCryptProtocolGuid

Detailed Description

The runtime cryptographic protocol. Only limited crypto primitives (SHA-256 and RSA) are provided for runtime authenticated variable service.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.

Define Documentation

#define EFI_RUNTIME_CRYPT_PROTOCOL_GUID

Value:

{ \
    0xe1475e0c, 0x1746, 0x4802, { 0x86, 0x2e, 0x1, 0x1c, 0x2c, 0x2d, 0x9d, 0x86 } \
  }
Runtime Cryptographic Protocol GUID.

Typedef Documentation

typedef IN RSA_KEY_TAG IN CONST UINT8* BigNumber

typedef IN RSA_KEY_TAG IN CONST UINT8 IN UINTN BnLength

typedef IN CONST VOID* Data

typedef IN CONST VOID IN UINTN DataLength

typedef VOID* EFIAPI* EFI_RUNTIME_CRYPT_RSA_NEW(VOID)

Allocates and Initializes one RSA Context for subsequent use.

Returns:
Pointer to the RSA Context that has been initialized. If the allocations fails, RsaNew() returns NULL.

typedef IN CONST UINT8 IN UINTN HashLength

typedef OUT UINT8* HashValue

typedef IN RSA_KEY_TAG KeyTag

typedef IN CONST UINT8* MessageHash

typedef IN CONST UINT8 IN UINTN IN UINT8 IN UINTN SigLength

typedef IN CONST UINT8 IN UINTN IN UINT8* Signature

Function Documentation

typedef BOOLEAN ( EFIAPI * EFI_RUNTIME_CRYPT_RSA_PKCS1_VERIFY )

Initializes user-supplied memory pointed by Sha256Context as SHA-256 hash context for subsequent use.

If Sha256Context is NULL, then ASSERT().

Parameters:
[in,out] Sha256Context Pointer to SHA-256 Context being initialized.
Return values:
TRUE | SHA-256 context initialization succeeded.
FALSE | SHA-256 context initialization failed.
Performs SHA-256 digest on a data buffer of the specified length. This function can be called multiple times to compute the digest of long or discontinuous data streams.

If Sha256Context is NULL, then ASSERT().

Parameters:
[in,out] | Sha256Context | Pointer to the SHA-256 context.
[in] | Data | Pointer to the buffer containing the data to be hashed.
[in] | DataLength | Length of Data buffer in bytes.
Return values:
TRUE | SHA-256 data digest succeeded.
FALSE | Invalid SHA-256 context. After Sha256Final function has been called, the SHA-256 context cannot be reused.
Completes SHA-256 hash computation and retrieves the digest value into the specified memory. After this function has been called, the SHA-256 context cannot be used again.

If Sha256Context is NULL, then ASSERT(). If HashValue is NULL, then ASSERT().

Parameters:
[in,out] | Sha256Context | Pointer to SHA-256 context
[out] | HashValue | Pointer to a buffer that receives the SHA-256 digest value (32 bytes).
Return values:
TRUE | SHA-256 digest computation succeeded.
FALSE | SHA-256 digest computation failed.
Sets the tag-designated RSA key component into the established RSA context from the user-specified nonnegative integer (octet string format represented in RSA PKCS#1).

If RsaContext is NULL, then ASSERT().

Parameters:
[in,out] | RsaContext | Pointer to RSA context being set.
[in] | KeyTag | Tag of RSA key component being set.
[in] | BigNumber | Pointer to octet integer buffer.
[in] | BnLength | Length of big number buffer in bytes.
Returns:
TRUE RSA key component was set successfully.

FALSE Invalid RSA key component tag.

Verifies the RSA-SSA signature with EMSA-PKCS1-v1_5 encoding scheme defined in RSA PKCS#1.

If RsaContext is NULL, then ASSERT(). If MessageHash is NULL, then ASSERT(). If Signature is NULL, then ASSERT(). If HashLength is not equal to the size of MD5, SHA-1 or SHA-256 digest, then ASSERT().

Parameters:
[in] | RsaContext | Pointer to RSA context for signature verification.
[in] | MessageHash | Pointer to octet message hash to be checked.
[in] | HashLength | Length of the message hash in bytes.
[in] | Signature | Pointer to RSA PKCS1-v1_5 signature to be verified.
[in] | SigLength | Length of signature in bytes.
Returns:
TRUE Valid signature encoded in PKCS1-v1_5.

FALSE Invalid signature or invalid RSA context.

typedef UINTN ( EFIAPI * EFI_RUNTIME_CRYPT_SHA256_GET_CONTEXT_SIZE )

Retrieves the size, in bytes, of the context buffer required for SHA-256 operations.

Returns:
The size, in bytes, of the context buffer required for SHA-256 operations.

typedef VOID ( EFIAPI * EFI_RUNTIME_CRYPT_RSA_FREE )

Release the specified RSA Context.

Parameters:
[in] RsaContext Pointer to the RSA context to be released.

Variable Documentation

EFI_GUID gEfiRuntimeCryptProtocolGuid


CryptoPkg[ALL]: CryptoPkg/Include/sys/ioctl.h File Reference

CryptoPkg/Include/sys/ioctl.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/sys/param.h File Reference

CryptoPkg/Include/sys/param.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/sys/socket.h File Reference

CryptoPkg/Include/sys/socket.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/sys/stat.h File Reference

CryptoPkg/Include/sys/stat.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/sys/time.h File Reference

CryptoPkg/Include/sys/time.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/sys/times.h File Reference

CryptoPkg/Include/sys/times.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/sys/types.h File Reference

CryptoPkg/Include/sys/types.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: CryptoPkg/Include/sys/un.h File Reference

CryptoPkg/Include/sys/un.h File Reference

Detailed Description

Include file to support building OpenSSL Crypto Library.

Copyright (c) 2010, Intel Corporation. All rights reserved.
This program and the accompanying materials are licensed and made available under the terms and conditions of the BSD License which accompanies this distribution. The full text of the license may be found at http://opensource.org/licenses/bsd-license.php

THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- _ -

  • __sighandler_t : OpenSslSupport.h


CryptoPkg[ALL]: Alphabetical List

  • Data Fields

Data Structure Index

D | E | S | T

D
E
S
T
tm
dirent EFI_RUNTIME_CRYPT_PROTOCOL stat

D | E | S | T


CryptoPkg[ALL]: Data Fields - Variables

  • Data Fields
  • All
  • Variables
  • d
  • r
  • s
  • t

- d -

  • d_fileno : dirent
  • d_name : dirent
  • d_namlen : dirent
  • d_reclen : dirent
  • d_type : dirent

- r -

  • RsaFree : EFI_RUNTIME_CRYPT_PROTOCOL
  • RsaNew : EFI_RUNTIME_CRYPT_PROTOCOL
  • RsaPkcs1Verify : EFI_RUNTIME_CRYPT_PROTOCOL
  • RsaSetKey : EFI_RUNTIME_CRYPT_PROTOCOL

- s -

  • Sha256Final : EFI_RUNTIME_CRYPT_PROTOCOL
  • Sha256GetContextSize : EFI_RUNTIME_CRYPT_PROTOCOL
  • Sha256Init : EFI_RUNTIME_CRYPT_PROTOCOL
  • Sha256Update : EFI_RUNTIME_CRYPT_PROTOCOL
  • st_atime : stat
  • st_atimensec : stat
  • st_blksize : stat
  • st_blocks : stat
  • st_ctime : stat
  • st_ctimensec : stat
  • st_dev : stat
  • st_flags : stat
  • st_gen : stat
  • st_gid : stat
  • st_ino : stat
  • st_lspare : stat
  • st_mode : stat
  • st_mtime : stat
  • st_mtimensec : stat
  • st_nlink : stat
  • st_qspare : stat
  • st_rdev : stat
  • st_size : stat
  • st_uid : stat

- t -

  • tm_gmtoff : tm
  • tm_hour : tm
  • tm_isdst : tm
  • tm_mday : tm
  • tm_min : tm
  • tm_mon : tm
  • tm_sec : tm
  • tm_wday : tm
  • tm_yday : tm
  • tm_year : tm
  • tm_zone : tm


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- k -

  • KeyTag : RuntimeCrypt.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- l -

  • localtime : OpenSslSupport.h
  • LOG_ALERT : OpenSslSupport.h
  • LOG_CONS : OpenSslSupport.h
  • LOG_CRIT : OpenSslSupport.h
  • LOG_DAEMON : OpenSslSupport.h
  • LOG_DEBUG : OpenSslSupport.h
  • LOG_EMERG : OpenSslSupport.h
  • LOG_ERR : OpenSslSupport.h
  • LOG_INFO : OpenSslSupport.h
  • LOG_NOTICE : OpenSslSupport.h
  • LOG_PID : OpenSslSupport.h
  • LOG_WARNING : OpenSslSupport.h
  • LONG_MAX : OpenSslSupport.h
  • LONG_MIN : OpenSslSupport.h
  • lseek() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- m -

  • malloc() : OpenSslSupport.h
  • MD4_DIGEST_SIZE : BaseCryptLib.h
  • Md4Duplicate() : BaseCryptLib.h
  • Md4Final() : BaseCryptLib.h
  • Md4GetContextSize() : BaseCryptLib.h
  • Md4Init() : BaseCryptLib.h
  • Md4Update() : BaseCryptLib.h
  • MD5_DIGEST_SIZE : BaseCryptLib.h
  • Md5Duplicate() : BaseCryptLib.h
  • Md5Final() : BaseCryptLib.h
  • Md5GetContextSize() : BaseCryptLib.h
  • Md5Init() : BaseCryptLib.h
  • Md5Update() : BaseCryptLib.h
  • memchr() : OpenSslSupport.h
  • memcmp : OpenSslSupport.h
  • memcpy : OpenSslSupport.h
  • memmove : OpenSslSupport.h
  • memset : OpenSslSupport.h
  • MessageHash : RuntimeCrypt.h
  • mode_t : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- n -

  • nlink_t : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- o -

  • off_t : OpenSslSupport.h
  • offsetof : OpenSslSupport.h
  • open() : OpenSslSupport.h
  • opendir() : OpenSslSupport.h
  • openlog() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- a -

  • abort : OpenSslSupport.h
  • AES_BLOCK_SIZE : BaseCryptLib.h
  • AesCbcDecrypt() : BaseCryptLib.h
  • AesCbcEncrypt() : BaseCryptLib.h
  • AesEcbDecrypt() : BaseCryptLib.h
  • AesEcbEncrypt() : BaseCryptLib.h
  • AesGetContextSize() : BaseCryptLib.h
  • AesInit() : BaseCryptLib.h
  • Arc4Decrypt() : BaseCryptLib.h
  • Arc4Encrypt() : BaseCryptLib.h
  • Arc4GetContextSize() : BaseCryptLib.h
  • Arc4Init() : BaseCryptLib.h
  • Arc4Reset() : BaseCryptLib.h
  • assert : OpenSslSupport.h
  • AuthenticodeVerify() : BaseCryptLib.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- b -

  • BigNumber : RuntimeCrypt.h
  • BnLength : RuntimeCrypt.h
  • BOOLEAN() : RuntimeCrypt.h
  • BUFSIZ : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- c -

  • chmod() : OpenSslSupport.h
  • clock_t : OpenSslSupport.h
  • close() : OpenSslSupport.h
  • closedir() : OpenSslSupport.h
  • closelog() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- d -

  • Data : RuntimeCrypt.h
  • DataLength : RuntimeCrypt.h
  • dev_t : OpenSslSupport.h
  • DhComputeKey() : BaseCryptLib.h
  • DhFree() : BaseCryptLib.h
  • DhGenerateKey() : BaseCryptLib.h
  • DhGenerateParameter() : BaseCryptLib.h
  • DhNew() : BaseCryptLib.h
  • DhSetParameter() : BaseCryptLib.h
  • DIR : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- e -

  • EFI_RUNTIME_CRYPT_PROTOCOL_GUID : RuntimeCrypt.h
  • EFI_RUNTIME_CRYPT_RSA_NEW : RuntimeCrypt.h
  • EINVAL : OpenSslSupport.h
  • ENOMEM : OpenSslSupport.h
  • errno : OpenSslSupport.h
  • exit() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- f -

  • fclose() : OpenSslSupport.h
  • fflush() : OpenSslSupport.h
  • fgets() : OpenSslSupport.h
  • FILE : OpenSslSupport.h
  • fopen() : OpenSslSupport.h
  • fprintf() : OpenSslSupport.h
  • fputs() : OpenSslSupport.h
  • fread() : OpenSslSupport.h
  • free() : OpenSslSupport.h
  • fwrite() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- g -

  • gEfiRuntimeCryptProtocolGuid : RuntimeCrypt.h
  • getegid() : OpenSslSupport.h
  • getenv() : OpenSslSupport.h
  • geteuid() : OpenSslSupport.h
  • getgid() : OpenSslSupport.h
  • getuid() : OpenSslSupport.h
  • gid_t : OpenSslSupport.h
  • gmtime() : OpenSslSupport.h
  • gmtime_r : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- h -

  • HashLength : RuntimeCrypt.h
  • HashValue : RuntimeCrypt.h
  • HmacMd5Duplicate() : BaseCryptLib.h
  • HmacMd5Final() : BaseCryptLib.h
  • HmacMd5GetContextSize() : BaseCryptLib.h
  • HmacMd5Init() : BaseCryptLib.h
  • HmacMd5Update() : BaseCryptLib.h
  • HmacSha1Duplicate() : BaseCryptLib.h
  • HmacSha1Final() : BaseCryptLib.h
  • HmacSha1GetContextSize() : BaseCryptLib.h
  • HmacSha1Init() : BaseCryptLib.h
  • HmacSha1Update() : BaseCryptLib.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- i -

  • ino_t : OpenSslSupport.h
  • INT_MAX : OpenSslSupport.h
  • INT_MIN : OpenSslSupport.h
  • isalnum() : OpenSslSupport.h
  • isdigit() : OpenSslSupport.h
  • isspace() : OpenSslSupport.h
  • isupper() : OpenSslSupport.h
  • isxdigit() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- p -

  • pid_t : OpenSslSupport.h
  • Pkcs7Sign() : BaseCryptLib.h
  • Pkcs7Verify() : BaseCryptLib.h
  • printf() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- q -

  • qsort() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- r -

  • RandomBytes() : BaseCryptLib.h
  • RandomSeed() : BaseCryptLib.h
  • read() : OpenSslSupport.h
  • readdir() : OpenSslSupport.h
  • realloc() : OpenSslSupport.h
  • RSA_KEY_TAG : BaseCryptLib.h
  • RsaCheckKey() : BaseCryptLib.h
  • RsaFree() : BaseCryptLib.h
  • RsaGenerateKey() : BaseCryptLib.h
  • RsaGetKey() : BaseCryptLib.h
  • RsaGetPrivateKeyFromPem() : BaseCryptLib.h
  • RsaGetPublicKeyFromX509() : BaseCryptLib.h
  • RsaKeyD : BaseCryptLib.h
  • RsaKeyDp : BaseCryptLib.h
  • RsaKeyDq : BaseCryptLib.h
  • RsaKeyE : BaseCryptLib.h
  • RsaKeyN : BaseCryptLib.h
  • RsaKeyP : BaseCryptLib.h
  • RsaKeyQ : BaseCryptLib.h
  • RsaKeyQInv : BaseCryptLib.h
  • RsaNew() : BaseCryptLib.h
  • RsaPkcs1Sign() : BaseCryptLib.h
  • RsaPkcs1Verify() : BaseCryptLib.h
  • RsaSetKey() : BaseCryptLib.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- s -

  • SHA1_DIGEST_SIZE : BaseCryptLib.h
  • Sha1Duplicate() : BaseCryptLib.h
  • Sha1Final() : BaseCryptLib.h
  • Sha1GetContextSize() : BaseCryptLib.h
  • Sha1Init() : BaseCryptLib.h
  • Sha1Update() : BaseCryptLib.h
  • SHA256_DIGEST_SIZE : BaseCryptLib.h
  • Sha256Duplicate() : BaseCryptLib.h
  • Sha256Final() : BaseCryptLib.h
  • Sha256GetContextSize() : BaseCryptLib.h
  • Sha256Init() : BaseCryptLib.h
  • Sha256Update() : BaseCryptLib.h
  • SigLength : RuntimeCrypt.h
  • signal() : OpenSslSupport.h
  • Signature : RuntimeCrypt.h
  • size_t : OpenSslSupport.h
  • sscanf() : OpenSslSupport.h
  • ssize_t : OpenSslSupport.h
  • stat() : OpenSslSupport.h
  • stderr : OpenSslSupport.h
  • stdin : OpenSslSupport.h
  • stdout : OpenSslSupport.h
  • strcasecmp() : OpenSslSupport.h
  • strcat : OpenSslSupport.h
  • strchr() : OpenSslSupport.h
  • strcmp : OpenSslSupport.h
  • strcpy : OpenSslSupport.h
  • strlen() : OpenSslSupport.h
  • strncasecmp() : OpenSslSupport.h
  • strncmp() : OpenSslSupport.h
  • strncpy : OpenSslSupport.h
  • strrchr() : OpenSslSupport.h
  • strtol() : OpenSslSupport.h
  • strtoul() : OpenSslSupport.h
  • syslog() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- t -

  • TDES_BLOCK_SIZE : BaseCryptLib.h
  • TdesCbcDecrypt() : BaseCryptLib.h
  • TdesCbcEncrypt() : BaseCryptLib.h
  • TdesEcbDecrypt() : BaseCryptLib.h
  • TdesEcbEncrypt() : BaseCryptLib.h
  • TdesGetContextSize() : BaseCryptLib.h
  • TdesInit() : BaseCryptLib.h
  • time() : OpenSslSupport.h
  • time_t : OpenSslSupport.h
  • tolower() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- u -

  • uid_t : OpenSslSupport.h
  • UINTN() : RuntimeCrypt.h
  • ULONG_MAX : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- v -

  • va_arg : OpenSslSupport.h
  • va_end : OpenSslSupport.h
  • va_list : OpenSslSupport.h
  • va_start : OpenSslSupport.h
  • vfprintf() : OpenSslSupport.h
  • VOID() : RuntimeCrypt.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- w -

  • write() : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • _
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • k
  • l
  • m
  • n
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x
Here is a list of all functions, variables, defines, enums, and typedefs with links to the files they belong to:

- x -

  • X509ConstructCertificate() : BaseCryptLib.h
  • X509ConstructCertificateStack() : BaseCryptLib.h
  • X509Free() : BaseCryptLib.h
  • X509GetSubjectName() : BaseCryptLib.h
  • X509StackFree() : BaseCryptLib.h
  • X509VerifyCert() : BaseCryptLib.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • a
  • b
  • e
  • g
  • i
  • l
  • m
  • o
  • s
  • t
  • u
  • v

- a -

  • abort : OpenSslSupport.h
  • AES_BLOCK_SIZE : BaseCryptLib.h
  • assert : OpenSslSupport.h

- b -

  • BUFSIZ : OpenSslSupport.h

- e -

  • EFI_RUNTIME_CRYPT_PROTOCOL_GUID : RuntimeCrypt.h
  • EINVAL : OpenSslSupport.h
  • ENOMEM : OpenSslSupport.h

- g -

  • gmtime_r : OpenSslSupport.h

- i -

  • INT_MAX : OpenSslSupport.h
  • INT_MIN : OpenSslSupport.h

- l -

  • localtime : OpenSslSupport.h
  • LOG_ALERT : OpenSslSupport.h
  • LOG_CONS : OpenSslSupport.h
  • LOG_CRIT : OpenSslSupport.h
  • LOG_DAEMON : OpenSslSupport.h
  • LOG_DEBUG : OpenSslSupport.h
  • LOG_EMERG : OpenSslSupport.h
  • LOG_ERR : OpenSslSupport.h
  • LOG_INFO : OpenSslSupport.h
  • LOG_NOTICE : OpenSslSupport.h
  • LOG_PID : OpenSslSupport.h
  • LOG_WARNING : OpenSslSupport.h
  • LONG_MAX : OpenSslSupport.h
  • LONG_MIN : OpenSslSupport.h

- m -

  • MD4_DIGEST_SIZE : BaseCryptLib.h
  • MD5_DIGEST_SIZE : BaseCryptLib.h
  • memchr : OpenSslSupport.h
  • memcmp : OpenSslSupport.h
  • memcpy : OpenSslSupport.h
  • memmove : OpenSslSupport.h
  • memset : OpenSslSupport.h

- o -

  • offsetof : OpenSslSupport.h

- s -

  • SHA1_DIGEST_SIZE : BaseCryptLib.h
  • SHA256_DIGEST_SIZE : BaseCryptLib.h
  • strcat : OpenSslSupport.h
  • strchr : OpenSslSupport.h
  • strcmp : OpenSslSupport.h
  • strcpy : OpenSslSupport.h
  • strlen : OpenSslSupport.h
  • strncmp : OpenSslSupport.h
  • strncpy : OpenSslSupport.h

- t -

  • TDES_BLOCK_SIZE : BaseCryptLib.h

- u -

  • ULONG_MAX : OpenSslSupport.h

- v -

  • va_arg : OpenSslSupport.h
  • va_end : OpenSslSupport.h
  • va_list : OpenSslSupport.h
  • va_start : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines

  • RSA_KEY_TAG : BaseCryptLib.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines

  • RsaKeyD : BaseCryptLib.h
  • RsaKeyDp : BaseCryptLib.h
  • RsaKeyDq : BaseCryptLib.h
  • RsaKeyE : BaseCryptLib.h
  • RsaKeyN : BaseCryptLib.h
  • RsaKeyP : BaseCryptLib.h
  • RsaKeyQ : BaseCryptLib.h
  • RsaKeyQInv : BaseCryptLib.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines
  • a
  • b
  • c
  • d
  • e
  • f
  • g
  • h
  • i
  • l
  • m
  • o
  • p
  • q
  • r
  • s
  • t
  • u
  • v
  • w
  • x

- a -

  • AesCbcDecrypt() : BaseCryptLib.h
  • AesCbcEncrypt() : BaseCryptLib.h
  • AesEcbDecrypt() : BaseCryptLib.h
  • AesEcbEncrypt() : BaseCryptLib.h
  • AesGetContextSize() : BaseCryptLib.h
  • AesInit() : BaseCryptLib.h
  • Arc4Decrypt() : BaseCryptLib.h
  • Arc4Encrypt() : BaseCryptLib.h
  • Arc4GetContextSize() : BaseCryptLib.h
  • Arc4Init() : BaseCryptLib.h
  • Arc4Reset() : BaseCryptLib.h
  • AuthenticodeVerify() : BaseCryptLib.h

- b -

  • BOOLEAN() : RuntimeCrypt.h

- c -

  • chmod() : OpenSslSupport.h
  • close() : OpenSslSupport.h
  • closedir() : OpenSslSupport.h
  • closelog() : OpenSslSupport.h

- d -

  • DhComputeKey() : BaseCryptLib.h
  • DhFree() : BaseCryptLib.h
  • DhGenerateKey() : BaseCryptLib.h
  • DhGenerateParameter() : BaseCryptLib.h
  • DhNew() : BaseCryptLib.h
  • DhSetParameter() : BaseCryptLib.h

- e -

  • exit() : OpenSslSupport.h

- f -

  • fclose() : OpenSslSupport.h
  • fflush() : OpenSslSupport.h
  • fgets() : OpenSslSupport.h
  • fopen() : OpenSslSupport.h
  • fprintf() : OpenSslSupport.h
  • fputs() : OpenSslSupport.h
  • fread() : OpenSslSupport.h
  • free() : OpenSslSupport.h
  • fwrite() : OpenSslSupport.h

- g -

  • getegid() : OpenSslSupport.h
  • getenv() : OpenSslSupport.h
  • geteuid() : OpenSslSupport.h
  • getgid() : OpenSslSupport.h
  • getuid() : OpenSslSupport.h
  • gmtime() : OpenSslSupport.h
  • gmtime_r() : OpenSslSupport.h

- h -

  • HmacMd5Duplicate() : BaseCryptLib.h
  • HmacMd5Final() : BaseCryptLib.h
  • HmacMd5GetContextSize() : BaseCryptLib.h
  • HmacMd5Init() : BaseCryptLib.h
  • HmacMd5Update() : BaseCryptLib.h
  • HmacSha1Duplicate() : BaseCryptLib.h
  • HmacSha1Final() : BaseCryptLib.h
  • HmacSha1GetContextSize() : BaseCryptLib.h
  • HmacSha1Init() : BaseCryptLib.h
  • HmacSha1Update() : BaseCryptLib.h

- i -

  • isalnum() : OpenSslSupport.h
  • isdigit() : OpenSslSupport.h
  • isspace() : OpenSslSupport.h
  • isupper() : OpenSslSupport.h
  • isxdigit() : OpenSslSupport.h

- l -

  • localtime() : OpenSslSupport.h
  • lseek() : OpenSslSupport.h

- m -

  • malloc() : OpenSslSupport.h
  • Md4Duplicate() : BaseCryptLib.h
  • Md4Final() : BaseCryptLib.h
  • Md4GetContextSize() : BaseCryptLib.h
  • Md4Init() : BaseCryptLib.h
  • Md4Update() : BaseCryptLib.h
  • Md5Duplicate() : BaseCryptLib.h
  • Md5Final() : BaseCryptLib.h
  • Md5GetContextSize() : BaseCryptLib.h
  • Md5Init() : BaseCryptLib.h
  • Md5Update() : BaseCryptLib.h
  • memchr() : OpenSslSupport.h
  • memcmp() : OpenSslSupport.h
  • memcpy() : OpenSslSupport.h
  • memmove() : OpenSslSupport.h
  • memset() : OpenSslSupport.h

- o -

  • open() : OpenSslSupport.h
  • opendir() : OpenSslSupport.h
  • openlog() : OpenSslSupport.h

- p -

  • Pkcs7Sign() : BaseCryptLib.h
  • Pkcs7Verify() : BaseCryptLib.h
  • printf() : OpenSslSupport.h

- q -

  • qsort() : OpenSslSupport.h

- r -

  • RandomBytes() : BaseCryptLib.h
  • RandomSeed() : BaseCryptLib.h
  • read() : OpenSslSupport.h
  • readdir() : OpenSslSupport.h
  • realloc() : OpenSslSupport.h
  • RsaCheckKey() : BaseCryptLib.h
  • RsaFree() : BaseCryptLib.h
  • RsaGenerateKey() : BaseCryptLib.h
  • RsaGetKey() : BaseCryptLib.h
  • RsaGetPrivateKeyFromPem() : BaseCryptLib.h
  • RsaGetPublicKeyFromX509() : BaseCryptLib.h
  • RsaNew() : BaseCryptLib.h
  • RsaPkcs1Sign() : BaseCryptLib.h
  • RsaPkcs1Verify() : BaseCryptLib.h
  • RsaSetKey() : BaseCryptLib.h

- s -

  • Sha1Duplicate() : BaseCryptLib.h
  • Sha1Final() : BaseCryptLib.h
  • Sha1GetContextSize() : BaseCryptLib.h
  • Sha1Init() : BaseCryptLib.h
  • Sha1Update() : BaseCryptLib.h
  • Sha256Duplicate() : BaseCryptLib.h
  • Sha256Final() : BaseCryptLib.h
  • Sha256GetContextSize() : BaseCryptLib.h
  • Sha256Init() : BaseCryptLib.h
  • Sha256Update() : BaseCryptLib.h
  • signal() : OpenSslSupport.h
  • sscanf() : OpenSslSupport.h
  • stat() : OpenSslSupport.h
  • strcasecmp() : OpenSslSupport.h
  • strcat() : OpenSslSupport.h
  • strchr() : OpenSslSupport.h
  • strcmp() : OpenSslSupport.h
  • strcpy() : OpenSslSupport.h
  • strlen() : OpenSslSupport.h
  • strncasecmp() : OpenSslSupport.h
  • strncmp() : OpenSslSupport.h
  • strncpy() : OpenSslSupport.h
  • strrchr() : OpenSslSupport.h
  • strtol() : OpenSslSupport.h
  • strtoul() : OpenSslSupport.h
  • syslog() : OpenSslSupport.h

- t -

  • TdesCbcDecrypt() : BaseCryptLib.h
  • TdesCbcEncrypt() : BaseCryptLib.h
  • TdesEcbDecrypt() : BaseCryptLib.h
  • TdesEcbEncrypt() : BaseCryptLib.h
  • TdesGetContextSize() : BaseCryptLib.h
  • TdesInit() : BaseCryptLib.h
  • time() : OpenSslSupport.h
  • tolower() : OpenSslSupport.h

- u -

  • UINTN() : RuntimeCrypt.h

- v -

  • vfprintf() : OpenSslSupport.h
  • VOID() : RuntimeCrypt.h

- w -

  • write() : OpenSslSupport.h

- x -

  • X509ConstructCertificate() : BaseCryptLib.h
  • X509ConstructCertificateStack() : BaseCryptLib.h
  • X509Free() : BaseCryptLib.h
  • X509GetSubjectName() : BaseCryptLib.h
  • X509StackFree() : BaseCryptLib.h
  • X509VerifyCert() : BaseCryptLib.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines

  • __sighandler_t : OpenSslSupport.h
  • BigNumber : RuntimeCrypt.h
  • BnLength : RuntimeCrypt.h
  • clock_t : OpenSslSupport.h
  • Data : RuntimeCrypt.h
  • DataLength : RuntimeCrypt.h
  • dev_t : OpenSslSupport.h
  • DIR : OpenSslSupport.h
  • EFI_RUNTIME_CRYPT_RSA_NEW : RuntimeCrypt.h
  • FILE : OpenSslSupport.h
  • gid_t : OpenSslSupport.h
  • HashLength : RuntimeCrypt.h
  • HashValue : RuntimeCrypt.h
  • ino_t : OpenSslSupport.h
  • KeyTag : RuntimeCrypt.h
  • MessageHash : RuntimeCrypt.h
  • mode_t : OpenSslSupport.h
  • nlink_t : OpenSslSupport.h
  • off_t : OpenSslSupport.h
  • pid_t : OpenSslSupport.h
  • SigLength : RuntimeCrypt.h
  • Signature : RuntimeCrypt.h
  • size_t : OpenSslSupport.h
  • ssize_t : OpenSslSupport.h
  • time_t : OpenSslSupport.h
  • uid_t : OpenSslSupport.h


CryptoPkg[ALL]: Data Fields

  • All
  • Functions
  • Variables
  • Typedefs
  • Enumerations
  • Enumerator
  • Defines

  • errno : OpenSslSupport.h
  • gEfiRuntimeCryptProtocolGuid : RuntimeCrypt.h
  • stderr : OpenSslSupport.h
  • stdin : OpenSslSupport.h
  • stdout : OpenSslSupport.h


CryptoPkg[ALL]: CryptoPkg/CryptoPkg.dec.decdoxygen File Reference

CryptoPkg/CryptoPkg.dec.decdoxygen File Reference

Generated on Wed Dec 14 16:19:32 2011 for CryptoPkg[ALL] by doxygen 1.5.7.1